checkRequire("Lua_RongLianUtil");
Lua_AdditionWindow = class("Lua_AdditionWindow", Lua_Window);
function Lua_AdditionWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AdditionWindow";
	self.skinName = "Addition_skin";
	self.w = 2000;
	self.h = 2000;
	self.blackAlpha = 1 / 255;
	self.isClickClose = true;
	self.showClose = false;
	self.showBg = false;
end

function Lua_AdditionWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showData = Lua_WindowUtil.getWinData("Lua_AdditionWindow", true);
	self.titleLbl.text = self:getTitle(self.showData.str);

	self.Label.text = string.format(self:getLabel(self.showData.str), self.showData.value);

	local amountArr = self:getAmount(self.showData.str);
	local _index = self:getIndex(self.showData.str, self.showData.value)
	self.curLbl.text = string.format(self:getCurLbl(self.showData.str), amountArr[_index]);

	self._blood = self:getBlood(self.showData.str, _index);
	self._attack = self:getAttack(self.showData.str, _index);
	self._defence = self:getDefence(self.showData.str, _index);
	self.propertyLbl.spacingY = 6;
	self.propertyLbl.text = string.format(self:getPropertyInfo(self.showData.str), self._blood, self._attack, self._defence);

	if _index ~= #amountArr then
		self.nextLbl.text = string.format(self:getCurLbl(self.showData.str), amountArr[_index + 1]);
		self._blood2 = self:getBlood(self.showData.str, _index + 1);
		self._attack2 = self:getAttack(self.showData.str, _index + 1);
		self._defence2 = self:getDefence(self.showData.str, _index + 1);
		self.propertyLbl2.spacingY = 6;
		self.propertyLbl2.text = string.format(self:getPropertyInfo(self.showData.str), self._blood2 , self._attack2 , self._defence2 );
	else
		self.nextLbl.text = LanUtil.getValue(110866);
		self.propertyLbl2.text = ""
	end
end

function Lua_AdditionWindow:getIndex(str, value)
	local arr = self:getAmount(str);
	local index = -1;
	local length = #arr;
	if arr == nil or length == 0 then
		return 1;
	end

	if length ~= 0 then
		for i = 1, length do
			if i + 1 <= length and arr[i] <= value and arr[i + 1] > value then
				index = i;
			end
		end
	end

	if index == -1 then
		if value < arr[1] then
			index = 1;
		end

		if value >= arr[length] then
			index = length;
		end
	end
	return index;
end

function Lua_AdditionWindow:getTitle(str)
	return getConfig( { "equipment_part", "extra_prop", str }).show_tips[1];
end
function Lua_AdditionWindow:getCurLbl(str)
	return getConfig( { "equipment_part", "extra_prop", str }).show_tips[2];
end
function Lua_AdditionWindow:getLabel(str)
	return getConfig( { "equipment_part", "extra_prop", str }).show_tips[3];
end
function Lua_AdditionWindow:getPropertyInfo(str)
	return getConfig( { "equipment_part", "extra_prop", str }).property_info;
end
function Lua_AdditionWindow:getAmount(str)
	return getConfig( { "equipment_part", "extra_prop", str }).amount;
end
function Lua_AdditionWindow:getAttack(str, index)
	return getConfig( { "equipment_part", "extra_prop", str }).attack[index];
end
function Lua_AdditionWindow:getDefence(str, index)
	return getConfig( { "equipment_part", "extra_prop", str }).defence[index];
end
function Lua_AdditionWindow:getBlood(str, index)
	return getConfig( { "equipment_part", "extra_prop", str }).blood[index];
end

function Lua_AdditionWindow:dispose()
    self:superCall("dispose");
end