Lua_CrimeLevelWindow = class("Lua_CrimeLevelWindow", Lua_Window);
function Lua_CrimeLevelWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CrimeLevelWindow";
	self.skinName = "CrimeLevel_skin";
	self.isClickClose = true;
end

function Lua_CrimeLevelWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 522, 240));
	self.dragContainer:setLocation(0, 20);
	self.dragContainer:updateChildPos();
	self.draggableCrimeText = Lua_CrimeLevelDesItem.new(self.dragContainer);
	LuaUtil.updateWindowDepth(nil);

	self.confirmBtn:addClickFuntion(self, self.hide);
end

function Lua_CrimeLevelWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_CrimeLevelDesItem = class("Lua_CrimeLevelDesItem", Lua_DragContainerItem);
function Lua_CrimeLevelDesItem:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub, "CrimeText_skin");

	dragContainer:addSubContainer(self, true);
end

function Lua_CrimeLevelDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.summary.text = LanUtil.getValue(110328);
	self.summary:setLocation(self.summary.mainContent.transform.localPosition.x, 120, 0);
end

function Lua_CrimeLevelDesItem:getHeight()
	return self.summary.height;
end