checkRequire("Lua_PackLeftPanel");
Lua_RolePanel = class("Lua_RolePanel", Lua_DisplayObject);
function Lua_RolePanel:ctor(p)
	self.aa = "aaa";
	self.aName = "Lua_RolePanel";
	self:superCall("ctor", p, "RolePanel_skin", true);
	self.showModel = true;
end

function Lua_RolePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftPanel = Lua_PackLeftPanel.new(self.content);
	self.leftPanel:setLocation(-306, 0, 0);

	self.paramBtn:addClickFuntion(self, self.onParamClick);
	self.detailBtn:addClickFuntion(self, self.onDetailClick);
	self.worldSp:addClickFuntion(self, self.onWorldSp);
	self.infoSp:addClickFuntion(self, self.onInfoSp);

	self:onProperUpdate(0);

	self:addLuaEvent("SHOWORCLOSE_BTN", self, self.showOrCloseBtn);
	self:addLuaEvent("ROLE_DATA_CHANGE", self, self.onProperUpdate);
	self:addLuaEvent("ROLE_HP_UPDATE", self, self.onProperUpdate);
	self:addLuaEvent("EQU_UPDATE", self, self.onEquUpdate);
	self:addLuaEvent("WING_UPDATE", self, self.onEquUpdate);
	self:addLuaEvent("PLAYER_KILL_VALUE", self, self.onPlayerKillValue);
	sendMsg(10400007);
	sendMsg(10400205);
	sendMsg(11403817);-- 获取穿戴神翼信息
end

function Lua_RolePanel:onEquUpdate(o)
	sendMsg(10400205);
end

function Lua_RolePanel:showOrCloseBtn(state)
	-- self.detailBtn:setEnable(state);
	self.rightObj:SetActive(state);
end

function Lua_RolePanel:onProperUpdate(obj)
	local roleData = DataCenter.roleData;
	self.hpBar:setMaxValue(roleData.maxHp);
	self.hpBar:setPercent(roleData.hp / roleData.maxHp);
	self.hpBar.txt:setEnable(true);
	self.hpBar.txt.text = (Lua_CommonUtil.getNumberTrans(roleData.hp) .. "/" .. Lua_CommonUtil.getNumberTrans(roleData.maxHp));

	self.mpBar:setMaxValue(roleData.maxMp);
	self.mpBar:setPercent(roleData.mp / roleData.maxMp);
	self.mpBar.txt:setEnable(true);
	self.mpBar.txt.text = (Lua_CommonUtil.getNumberTrans(roleData.mp) .. "/" .. Lua_CommonUtil.getNumberTrans(roleData.maxMp));

	local lexp = Lua_ThingDefine.getLevelExp(roleData.level);
	self.expBar:setPercent(roleData.exp / lexp);
	self.expBar.txt:setEnable(true);
	self.expBar.txt.text = (Lua_CommonUtil.getNumberTrans(roleData.exp) .. "/" .. Lua_CommonUtil.getNumberTrans(lexp));

	self.jobTxt.text = Lua_ThingDefine.getJobName(roleData.career, roleData.profession);
	self.lvTxt.text = tostring(roleData.level);
	self.goodTxt.text = tostring(roleData.kill_value);

	if roleData.leagueName == nil or roleData.leagueName == "" then
		self.factionTxt.text = LanUtil.getValue(20);
	else
		self.factionTxt.text = roleData.leagueName;
	end

	if tostring(roleData.partnerName) ~= "" then --伴侣信息
		self.banlvTxt.text = tostring(roleData.partnerName);
	else
		self.banlvTxt.text = LanUtil.getValue(20);
	end

	self.attTxt.text = tostring(roleData.attack_lower).."-"..tostring(roleData.attack_upper);
	self.defTxt.text = tostring(roleData.defence);
	self.minTxt.text = tostring(roleData.hit);
	self.shanTxt.text = tostring(roleData.dodge);
	self.criTxt.text = tostring(roleData.crit);
	self.renTxt.text = tostring(roleData.toughness);
end

function Lua_RolePanel:onPlayerKillValue(o)
	self.goodTxt.text = tostring(DataCenter.roleData.kill_value);
end

function Lua_RolePanel:onParamClick(go)
	self:showOrCloseBtn(false);
	Lua_WindowUtil.openWin("Lua_PropertyIllustrationWindow");
end

function Lua_RolePanel:onDetailClick(go)
	self:showOrCloseBtn(false);
	Lua_WindowUtil.openWin("Lua_PropertyDetailWindow");
end

function Lua_RolePanel:onWorldSp(go)
	Lua_WindowUtil.openWin("Lua_WorldLevelWindow");
end

function Lua_RolePanel:onInfoSp(go)
	Lua_WindowUtil.openWin("Lua_CrimeLevelWindow");
end

function Lua_RolePanel:dispose()
	if self.leftPanel ~= nil then
		self.leftPanel:dispose();
		self.leftPanel = nil;
	end
	self:superCall("dispose");

	Lua_WindowUtil.openWin("Lua_CrimeLevelWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_WorldLevelWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_PropertyDetailWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_PropertyIllustrationWindow", WinParam.ACTION_CLOSE);
end