checkRequire("Lua_SkillSingle");
checkRequire("Lua_SkillSetItem");
Lua_SkillInformationPanel = class("Lua_SkillInformationPanel", Lua_DisplayObject);
function Lua_SkillInformationPanel:ctor(p)
	self:superCall("ctor", p, "SkillInformationPanel_skin", false);
end

function Lua_SkillInformationPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.isAuto = false;
	self.redDot:setEnable(false);

	--获取技能相关数据
	self:addLuaEvent("SKILL_UPDATE_DATA", self, self.updateSkillData);
	self:addLuaEvent("SHOW_DRAG_ICON_CAREER", self, self.onShowDragIconCareer);
	self:addLuaEvent("SHOW_DRAG_ICON_SET", self, self.onShowDragIconSet);
	self:addLuaEvent("SET_REDDOT_SHOW", self, self.setRedDotShow);

	self.dragContainer_left = Lua_DragContainer.new(self.content, 1, Vector4(-322, 52, 563, 460));
	self.dragContainer_left:setLocation(0, 0, 0);
	self.dragContainer_left.uiPanel.depth = 3000;
	self.draggableSkillItemPanel = Lua_SkillItemPanel.new(self.dragContainer_left);
	LuaUtil.updateWindowDepth(nil);

	self.dragContainer_right = Lua_DragContainer.new(self.content,1, Vector4(255, 0, 510, 440));
	self.dragContainer_right:setLocation(-8, 5, 0);
	self.dragContainer_right.uiPanel.depth = 3000;
	self.dragContainer_right.canDrag = false;
	self.draggableSkillInfoPanel = Lua_SkillInfoPanel.new(self.dragContainer_right);
	LuaUtil.updateWindowDepth(nil);

	self.upgradeBtn:addClickFuntion(self, self.onUpgradeClick)
	self.autoUpgradeBtn:addClickFuntion(self, self.onAutoUpgradeClick)

	self.help.text = LanUtil.getValue(110611)
	self.help.clickScale = false;
	self.help:addClickFuntion(self, self.onHelpClick)

	-- 技能设置层
	local item;
	self.setPassiveSkills = Array();
	for i = 1, 4 do
		item = Lua_SkillSetItem.new(self.content);
		item.data = nil;
		item:setIndex(i);
		item:setLocation(-493 + (i - 1) * 129, -268, 0);
		self.setPassiveSkills:add(item); 
	end

	if DataCenter.skillData == nil then
		return;
	end
	local suitList = DataCenter.skillData:getSkillSuitList(0);    
	if suitList == nil then
		return;
	end

	local len = suitList.careerSkills:getSize();
	if len > 0 then
		Lua_MsgUtil.callFunc("SKILL_UPDATE_DATA", suitList.careerSkills[1]);
	end
	self:updateSlotSkill(false);
end

function Lua_SkillInformationPanel:dispose()
	self:stopAuto();
	self:superCall("dispose");
end

function Lua_SkillInformationPanel:updateSlotSkill(val)
	local skillId;
	for i = 1, self.setPassiveSkills:getSize() do
		skillId = DataCenter.skillData:getSlotSkill(i);
		if skillId ~= nil then
			local skillVo = DataCenter.skillData:getSkillData(skillId);
			if skillVo:hasLearn() then
				self.setPassiveSkills[i].data = skillVo;
			else
				self.setPassiveSkills[i].data = nil;
			end
		end
	end

	if val == true then
		local slotDic = DataCenter.skillData.slotToSkillDic;
		local info;
		local cmd = ProtoPublic_pb.Proto10400702();
		for k,v in pairs(slotDic) do
			info = ProtoPublic_pb.ProtoPairObj();
			info.obj_id = k;
			info.obj_value = v;
			cmd.skill_key_map:addToList(info);
		end
		sendMsg(10400702, cmd);
		Lua_MsgUtil.callFunc("SKILL_SHOW");
	end
end

function Lua_SkillInformationPanel:updateSkillData(obj)
	self.slectedData = obj;   
	if obj ~= nil then
		self.skillNameTxt.text = tostring(obj.name);
		local svo_data = obj;
		if DataCenter.roleData.level < svo_data:getUseLvl(1) then
			self.levelTxt.text = LanUtil.formateStr(LanUtil.getValue(110602))
		else
			if svo_data.skillLv == 0 then
				self.levelTxt.text = LanUtil.formateStr(LanUtil.getValue(110603), "1");
			else
				self.levelTxt.text = LanUtil.formateStr(LanUtil.getValue(110603), tostring(svo_data.skillLv));
			end
		end
	end

	if obj.skillLv >= obj.maxLevel or obj.config.skill_type == 7 then
		self.autoUpgradeBtn:setEnable(false);
		self.upgradeBtn:setEnable(false);
	else
		self.autoUpgradeBtn:setEnable(true);
		self.upgradeBtn:setEnable(true);
	end
end

function Lua_SkillInformationPanel:onShowDragIconCareer(obj)
	self:showDragIcon(1, obj);
end

function Lua_SkillInformationPanel:onShowDragIconSet(obj)
	self:showDragIcon(2, obj);
end

function Lua_SkillInformationPanel:setRedDotShow(redState)
	self.redDot:setEnable(redState);
end

function Lua_SkillInformationPanel:showDragIcon(from, data)
	if data == nil then
		return;
	end

	local recieveItems = Array();
	for i = 1, self.setPassiveSkills:getSize() do
		recieveItems:add(self.setPassiveSkills[i]:getRecieveBox());
	end
	Lua_WindowUtil.openWin("Lua_DragAndDropWindow", WinParam.ACTION_OPEN, {owner = self, callBack = self.onSetSkillReviece,
	atlas = data.atlas, spiteName = data.skillIcon, recieveItems = recieveItems, dragData = {from = from, skillData = data}});
end

function Lua_SkillInformationPanel:onSetSkillReviece(box, data)
	local newSlot = tonumber(box.name);
	local newSkillId = data.skillData.skillId;
	local oldSlotSkill = DataCenter.skillData:getSlotSkill(newSlot); 
	local oldSlotIndex = DataCenter.skillData:getSkillSlot(newSkillId); 
	if oldSlotIndex ~= nil then
		DataCenter.skillData:setSlot(oldSlotIndex, oldSlotSkill);
	end
	DataCenter.skillData:setSlot(newSlot, newSkillId);
	self:updateSlotSkill(true);
end

function Lua_SkillInformationPanel:onHelpClick(go)
	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.SHILIAN_COPY);
	if copyVo.open_lv > DataCenter.roleData.level then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121147), tostring(copyVo.open_lv)));
		return;
	end
	Lua_WindowUtil.openWin("Lua_CopyWindow");
	Lua_WindowUtil.openWin("Lua_CopyMoneyWindow", nil, Lua_CopyData.SHILIAN_COPY);
end

function Lua_SkillInformationPanel:onUpgradeClick(go)
	local svo_data = self.slectedData;
	if svo_data:hasLearn() == false then
		OperateAlert.show(LanUtil.getValue(110635));
		return false;
	end

	if svo_data.skillLv >= svo_data.maxLevel then
		OperateAlert.show(LanUtil.getValue(110634));
		return false;
	end

	local slv = 1;
	if svo_data:hasLearn() then
		slv = svo_data.skillLv + 1;
	end

	-- 需要人物到达的等级
	local needLv = svo_data:getUseLvl(slv);
	if needLv > DataCenter.roleData.level then
		OperateAlert.show(LanUtil.getValue(110604));
		return false;
	end

	local needMoney = svo_data:getMoney(slv);
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.COPPER, needMoney, true, false) == false then
		return false;
	end

	local needSavvy = svo_data:getSavvy(slv - 1);
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.SAVVY, needSavvy, true, false) == false then
		return false;
	end

	local cmd = ProtoPublic_pb.Proto10400711();
	cmd.skill_id = self.slectedData.skillId;
	sendMsg(10400711, cmd);
	return true;
end

function Lua_SkillInformationPanel:onAutoUpgradeClick(go)
	if self.isAuto == false then
		self:startAuto();
	else
		self:stopAuto();
	end
end

function Lua_SkillInformationPanel:startAuto()
	if self.isAuto == false then
		Lua_CommonUtil.addTimer("SkillInformation", .1, self, self.autoUpgrade)
		self.isAuto = true
		self.autoUpgradeBtn.label = LanUtil.getValue(110632)
	end
end

function Lua_SkillInformationPanel:stopAuto()
	if self.isAuto == true then
		self.isAuto = false
		Lua_CommonUtil.removeTimer(self, self.autoUpgrade);
		self.autoUpgradeBtn.label = LanUtil.getValue(110631);
	end
end

function Lua_SkillInformationPanel:autoUpgrade()
    local rs = self:onUpgradeClick(nil);
    if rs == false then
        self:stopAuto();
    end
end





--------------------------------------------------





-- ******左侧的技能图标滑动容器类******
Lua_SkillItemPanel = class("Lua_SkillItemPanel", Lua_DragContainerItem);
function Lua_SkillItemPanel:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub, "SkillItem_skin", false);
	dragContainer:addSubContainer(self, true);
end

function Lua_SkillItemPanel:getHeight()
    return 700;
end

function Lua_SkillItemPanel:buildShowItem()
	self:superCall("buildShowItem")

	self.careerSkillObj = Array();
	self.allSkillArr = Array();
	self.passiveSkillObj = Array();
	self.qiyuanSkillObj = Array();

	local careerSkillObjPos = {{-548, 180}, {-398, 180}, {-248, 180}, {-98, 180}};
	local obj;
	for i,v in ipairs(careerSkillObjPos) do
		obj = Lua_SkillSingle.new(self.content, true);
		obj:setLocation(v[1], v[2]);
		obj.content.name = "careerSkillObj_"..i;
		obj:setData(nil);
		self.careerSkillObj:add(obj);
		self.allSkillArr:add(obj);
	end

	local passiveSkillObjPos = {{-548, -41}, {-398, -41}, {-248, -41}, {-98, -41}};
	for i,v in ipairs(passiveSkillObjPos) do
		obj = Lua_SkillSingle.new(self.content, false);
		obj:setLocation(v[1], v[2]);
		obj.content.name = "passiveSkillObj_"..i;
		obj:setData(nil);
		self.passiveSkillObj:add(obj);
		self.allSkillArr:add(obj);
	end

	if Lua_SkillDefine.getSkillByCareer(DataCenter.roleData.career).passiveSkills:getSize() == 4 then
		local qiyuanSkillObjPos = {{-548, -188}, {-398, -188}, {-248, -188}, {-98, -188}, {-548, -335}};
		for i,v in ipairs(qiyuanSkillObjPos) do
			obj = Lua_SkillSingle.new(self.content, false);
			obj:setLocation(v[1], v[2]);
			obj.content.name = "qiyuanSkillObj_"..i;
			obj:setData(nil);
			self.qiyuanSkillObj:add(obj);
			self.allSkillArr:add(obj);
		end    
	elseif Lua_SkillDefine.getSkillByCareer(DataCenter.roleData.career).passiveSkills:getSize() == 3 then
		local qiyuanSkillObjPos = {{-98, -41}, {-548, -188}, {-398, -188}, {-248, -188}, {-98, -188}};
		for i,v in ipairs(qiyuanSkillObjPos) do
			obj = Lua_SkillSingle.new(self.content, false);
			obj:setLocation(v[1], v[2]);
			obj.content.name = "qiyuanSkillObj_"..i;
			obj:setData(nil);
			self.qiyuanSkillObj:add(obj);
			self.allSkillArr:add(obj);
		end
	elseif Lua_SkillDefine.getSkillByCareer(DataCenter.roleData.career).passiveSkills:getSize() == 2 then
		local qiyuanSkillObjPos = {{-248, -41}, {-98, -41}, {-548, -188}, {-398, -188}, {-248, -188}};
		for i,v in ipairs(qiyuanSkillObjPos) do
			obj = Lua_SkillSingle.new(self.content, false);
			obj:setLocation(v[1], v[2]);
			obj.content.name = "qiyuanSkillObj_"..i;
			obj:setData(nil);
			self.qiyuanSkillObj:add(obj);
			self.allSkillArr:add(obj);
		end
	end
	self:addLuaEvent("SKILL_SHOW", self, self.onSkillShow);
	self:onSkillShow();
	self:addLuaEvent("SKILL_UPDATE_DATA", self, self.getSelected);
	self:addLuaEvent("SKILL_UPDATE_DATA", self, self.upgradeRedDot);
end

function Lua_SkillItemPanel:upgradeRedDot(val)
	if DataCenter.skillData == nil then
		return;
	end

	local suitList = DataCenter.skillData:getSkillSuitList(0);    
	if suitList == nil then
		return;
	end

	local len = suitList.careerSkills:getSize();
	local svo_data;
	local index = 0;
	for i = 1, len do
		svo_data = suitList.careerSkills[i];
		if svo_data.defaultSkill == 0 then
			index = index + 1;
			if svo_data.canUpdate then
				self.careerSkillObj:getItem(index):setRedDotState(true);
			else
				self.careerSkillObj:getItem(index):setRedDotState(false);
			end
		end
	end

	len = suitList.passiveSkills:getSize();
	index = 0;
	for i = 1, len do
		svo_data = suitList.passiveSkills[i]
		if svo_data.defaultSkill == 0 then
			index = index + 1;
			if svo_data.canUpdate then
				self.passiveSkillObj:getItem(i):setRedDotState(true);
			else
				self.passiveSkillObj:getItem(i):setRedDotState(false);
			end
		end
	end

	len = suitList.qiyuanSkills:getSize();
	index = 0;
	for i = 1, len do
		svo_data = suitList.qiyuanSkills[i]
		if svo_data.defaultSkill == 0 then
			index = index + 1;
			if svo_data.canUpdate then
				self.qiyuanSkillObj:getItem(i):setRedDotState(true);
			else
				self.qiyuanSkillObj:getItem(i):setRedDotState(false);
			end
		end
	end
end

function Lua_SkillItemPanel:getSelected(obj)
	if self.allSkillArr ~= nil then
		for i = 1, self.allSkillArr:getSize() do
			self.allSkillArr:getItem(i).skillSelected.uiwidget.gameObject:SetActive(false);  
			if self.allSkillArr:getItem(i).skillNameLabel.text == tostring(obj.name) then
				self.allSkillArr:getItem(i).skillSelected.uiwidget.gameObject:SetActive(true);
			end
		end
	end
end

function Lua_SkillItemPanel:onSkillShow()
	if DataCenter.skillData == nil then
		return;
	end

	local suitList = DataCenter.skillData:getSkillSuitList(0);    
	if suitList == nil then
		return;
	end

	local len = suitList.careerSkills:getSize();
	for i = 1, len do
		if self.careerSkillObj[i] ~= nil then
			self.careerSkillObj[i]:setData(suitList.careerSkills[i]);
		end
	end

	for i = 1, self.passiveSkillObj:getSize() do
		self.passiveSkillObj[i]:setEnable(false);
	end

	len = suitList.passiveSkills:getSize();
	for i = 1, len do
		if self.passiveSkillObj[i] ~= nil then
			self.passiveSkillObj[i]:setEnable(true);
			self.passiveSkillObj[i]:setData(suitList.passiveSkills[i]);
		end
	end

	len = suitList.qiyuanSkills:getSize();
	for i = 1, len do
		if self.qiyuanSkillObj[i] ~= nil then
			self.qiyuanSkillObj[i]:setData(suitList.qiyuanSkills[i]);
		end
	end
end





--------------------------------------------------





-- ******右侧的技能详细信息滑动容器类******
Lua_SkillInfoPanel = class("Lua_SkillInfoPanel", Lua_DragContainerItem);
function Lua_SkillInfoPanel:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub, "SkillInfo_skin", false);
	dragContainer:addSubContainer(self,true);
end

function Lua_SkillInfoPanel:getHeight()
	return 500;
end

function Lua_SkillInfoPanel:buildShowItem()
	self:superCall("buildShowItem"); 

	--获取技能相关的数据
	self:addLuaEvent("SKILL_UPDATE_DATA", self, self.updateSkillData);

	local timg
	self.boardList = Array();
	for i = 1, 2 do
		timg = Lua_ToolImage.new(self.content);
		timg:setDepth(6);
		timg:setLocation(152 + 90 * (i - 1), -147.5);
		timg:showNum(0, true);
		self.boardList:add(timg);
	end
end

function Lua_SkillInfoPanel:updateSkillData(obj)
	local svo_data = obj;
	--技能类型
	if obj.skillType == 1 then
		self.skillTypeText.text = LanUtil.getValue(110600)
	elseif obj.skillType > 1 then
		self.skillTypeText.text = LanUtil.getValue(110601)
	end

	--蓝耗
	self.useMpTxt.text = tostring(obj.costMagic)

	--技能CD
	self.cdTxt.text = LanUtil.formateStr(LanUtil.getValue(110612), tostring(obj.cool))

	--当前效果描述
	local skillLv = svo_data.skillLv;
	if skillLv == 0 then
		skillLv = 1;
	end

	local maxLen = table.getn(svo_data.config.detail);
	local curEffect = svo_data.config.detail[skillLv].effect[1]
	local nextEffect = nil;
	local maxEffect = nil;
	if svo_data.config.skill_type ~= 7 then   --奇缘技能就一级
		if maxLen > skillLv then
			nextEffect = svo_data.config.detail[skillLv + 1].effect[1]
		else
			maxEffect = svo_data.config.detail[maxLen].effect[1]
		end
	end 

	if curEffect ~= nil then
		local p = curEffect.percent == nil and 0 or curEffect.percent;
		local v = curEffect.value == nil and 0 or curEffect.value;
		self.curEffectTxt.text = LanUtil.getValue(110620)..LanUtil.formateStr(obj.des, tostring(math.abs(p)), tostring(v));
	end

	local redState = false;
	-- 下级效果描述
	if svo_data.skillLv >= svo_data.maxLevel or svo_data.config.skill_type == 7 then
		if svo_data.config.skill_type == 7 and svo_data.skillLv < svo_data.maxLevel  then
			self.nextEffectTxt.text = svo_data.config.activate_tips;
		else
			if svo_data.config.skill_type == 7 then
				--奇缘技能显示“技能已激活”
				self.nextEffectTxt.text = "["..Lua_ColorDefine.GREEN_STR.."]"..LanUtil.getValue(110650).."[-]";
			else
				self.nextEffectTxt.text = "["..Lua_ColorDefine.RED_STR.."]"..LanUtil.getValue(110634).."[-]";
			end
		end
		self.fengexian:setEnable(false);
		self.needLvLabel:setEnable(false);
		self.needLvTxt:setEnable(false);
		self.needUseLabel:setEnable(false);
		self.boardList[1]:setEnable(false);
		self.boardList[2]:setEnable(false);
		self.numLabel:setEnable(false)
	else
		self.fengexian:setEnable(true);
		self.needLvLabel:setEnable(true);
		self.needLvTxt:setEnable(true);
		self.needUseLabel:setEnable(true);
		self.numLabel:setEnable(true);

		local p;
		local v;
		if maxLen > skillLv then
			p = nextEffect.percent == nil and 0 or nextEffect.percent;
			v = nextEffect.value == nil and 0 or nextEffect.value;
		else
			p = maxEffect.percent == nil and 0 or maxEffect.percent;
			v = maxEffect.value == nil and 0 or maxEffect.value;
		end
		self.nextEffectTxt.text = LanUtil.getValue(110621)..LanUtil.formateStr(obj.des, tostring(math.abs(p)), tostring(v))

		local slv = 1;
		if svo_data:hasLearn() then
			slv = svo_data.skillLv + 1;
		end

		-- 需要人物到达的等级
		local needLv = svo_data:getUseLvl(slv);
		if needLv <= DataCenter.roleData.level then
			self.needLvTxt.text = "["..Lua_ColorDefine.GREEN_STR.."]"..needLv..LanUtil.getValue(110607).."[-]";
		else
			self.needLvTxt.text = "["..Lua_ColorDefine.RED_STR.."]"..needLv..LanUtil.getValue(110607).."[-]";
		end

		-- 升级技能消费的金币
		local needMoney = svo_data:getMoney(slv); 
		self.boardList[1]:setEnable(false);
		self.boardList[2]:setEnable(false);
		self.numLabel:setEnable(false)
		local itemIndex = 1;
		if needMoney > 0 then
			self.boardList[itemIndex]:setEnable(true);
			self.boardList[itemIndex].data = Lua_ToolVo.new(209000001, tonumber(needMoney),2);
			self.boardList[itemIndex].num_txt:setEnable(true);
			if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.COPPER, needMoney, false, false) == true then
				self.boardList[itemIndex].num_txt.text = "["..Lua_ColorDefine.GREEN_STR.."]"..needMoney.."[-]";
			else
				self.boardList[itemIndex].num_txt.text = "["..Lua_ColorDefine.RED_STR.."]"..needMoney.."[-]";
			end
			itemIndex = itemIndex + 1;
		end

		-- 升级技能消费的悟性点
		local needSavvy = svo_data:getSavvy(slv - 1);
		if needSavvy > 0 then
			self.numLabel:setEnable(true)
			self.boardList[itemIndex]:setEnable(true);
			self.boardList[itemIndex].data = Lua_ToolVo.new(209000008);
			if tonumber(DataCenter.moneyData:getMoney(Lua_MoneyData.SAVVY)) >= tonumber(needSavvy) then 
				self.numLabel.text = "[85A8BE]"..tostring(DataCenter.moneyData:getMoney(Lua_MoneyData.SAVVY)).."/".. tostring(needSavvy).."[-]";
				redState = svo_data:hasLearn();
			else  
				self.numLabel.text = "["..Lua_ColorDefine.RED_STR.."]"..tostring(DataCenter.moneyData:getMoney(Lua_MoneyData.SAVVY)).."[-]".."[85A8BE]".."/"..tostring(needSavvy);
			end
		end
	end
	Lua_MsgUtil.callFunc("SET_REDDOT_SHOW", redState);
end