Lua_SkillSetItem = class("Lua_SkillSetItem", Lua_DisplayObject);
function Lua_SkillSetItem:ctor(p)
	self:superCall("ctor", p, "SkillSetItem_skin");
end

function Lua_SkillSetItem:buildShowItem()
	self:superCall("buildShowItem");

	self.skillBg.clickScale = false;
	self.skillBg:addClickFuntion(self, self.onSkillClick);
	self.skillBg:addMouseUpFuntion(self, self.onMouseUp);
end

function Lua_SkillSetItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCheckMoving);
	self:superCall("dispose");
end

function Lua_SkillSetItem:onMouseUp(go)
	self.isMouseDown = false;
	Lua_WindowUtil.openWin("Lua_DragAndDropWindow", WinParam.ACTION_CLOSE);
	Lua_CommonUtil.removeTimer(self, self.onCheckMoving);
end

function Lua_SkillSetItem:setIndex(val)
	self.index = val;
end

function Lua_SkillSetItem:getRecieveBox()
	self.skillBg.name = tostring(self.index);
	return self.skillBg;
end

function Lua_SkillSetItem.Get:data()
	return self._data;
end

function Lua_SkillSetItem.Set:data(val)
	self._data = val;
	if self._data == nil then
		self.skillIcon:setEnable(false);
		self.skillIcon:setAltas(nil, nil);
	else
		self.skillIcon:setEnable(true);
		self.skillIcon:setAltas(self._data.atlas, self._data.skillIcon);
	end
end

function Lua_SkillSetItem:onSkillClick(go)
	self.startX = UnityEngine.Input.mousePosition.x;
	self.startY = UnityEngine.Input.mousePosition.y;
	self.isMouseDown = true;
	self.startClickTime = getTime();
	Lua_CommonUtil.addTimer("onCheckMoving", 0.01, self, self.onCheckMoving);
end

function Lua_SkillSetItem:onCheckMoving()
	local lx = math.abs(UnityEngine.Input.mousePosition.x - self.startX);
	local ly = math.abs(UnityEngine.Input.mousePosition.y - self.startY);
	if self.isMouseDown == true and lx + ly < 4 and getTime() - self.startClickTime > 0.5 then
		Lua_MsgUtil.callFunc("SHOW_DRAG_ICON_SET", self._data);
		Lua_CommonUtil.removeTimer(self, self.onCheckMoving);
	end
end