Lua_SkillSingle = class("Lua_SkillSingle", Lua_DisplayObject);
function Lua_SkillSingle:ctor(p, canDrag)
	self.canDrag = canDrag == nil and false or canDrag;
	self:superCall("ctor", p, "SkillSingle_skin", false);
end

function Lua_SkillSingle:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("SKILL_UPDATE_DATA", self, self.onSkillUpdate);

	self.skillIcon.clickScale = false;
	self.skillIcon:addClickFuntion(self, self.showSkillInfo);
	self.skillIcon:addMouseUpFuntion(self, self.onMouseUp);

	self.skillSelected:setEnable(false);
	self.redDotImg:setEnable(false);
end

function Lua_SkillSingle:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCheckMoving);
	self:superCall("dispose");
end

function Lua_SkillSingle:onSkillUpdate(obj)
	if self._data == nil then
		return;
	end

	if obj.skillId == self._data.skillId then
		self:setData(obj);
	end
end

function Lua_SkillSingle:onMouseUp(go)
	self.isMouseDown = false;
	Lua_WindowUtil.openWin("Lua_DragAndDropWindow", WinParam.ACTION_CLOSE);
	Lua_CommonUtil.removeTimer(self, self.onCheckMoving);
end

function Lua_SkillSingle:onCheckMoving()
	local lx = math.abs(UnityEngine.Input.mousePosition.x - self.startX);
	local ly = math.abs(UnityEngine.Input.mousePosition.y - self.startY);
	if self.isMouseDown == true and lx + ly < 4 and getTime() - self.startClickTime > 0.5 then
		Lua_MsgUtil.callFunc("SHOW_DRAG_ICON_CAREER", self._data);
		Lua_CommonUtil.removeTimer(self, self.onCheckMoving);
	end
end

function Lua_SkillSingle:setData(data)
	self._data = data;
	local rd = DataCenter.roleData;

	if self._data ~= nil then
		if data:hasLearn() == false then
			self.skillIcon:setGray(true);
			self.lvTxt = LanUtil.formateStr(LanUtil.getValue(110602))
			if self._data.skillType == 1 then
				self.skillLevel.text = LanUtil.formateStr(LanUtil.getValue(110609), tostring(self._data:getActiveLv()));
			elseif self._data.skillType > 1 and self._data.skillType < 7 then
				self.skillLevel.text = LanUtil.formateStr(LanUtil.getValue(110610), tostring(self._data.changeJob));
			elseif self._data.skillType == 7 then
				self.skillLevel.text = "[FF1616]" .. self._data.activate .. "[-]";
			end
			self.isActivate = false
			self.redDotImg:setEnable(false)
		else
			self.skillLevel.text = LanUtil.formateStr(LanUtil.getValue(110608), tostring(self._data.skillLv));
			self.skillIcon:setGray(false);
			self.lvTxt = LanUtil.formateStr(LanUtil.getValue(110603), tostring(self._data.skillLv));
			self.isActivate = true
		end
		self.skillNameLabel.text = self._data.name;
		self.skillIcon:setAltas(self._data.atlas, self._data.skillIcon)
	end
end

function Lua_SkillSingle:setRedDotState(val)
	self.redDotImg:setEnable(val)
end

function Lua_SkillSingle:showSkillInfo(go)
	if self.canDrag == true and self._data:hasLearn() then
		self.startX = UnityEngine.Input.mousePosition.x;
		self.startY = UnityEngine.Input.mousePosition.y;
		self.startClickTime = getTime();
		Lua_CommonUtil.addTimer("onCheckMoving", 0.01, self, self.onCheckMoving);
	end
	self.isMouseDown = true;
	-- 抛出技能数据相关的结构体
	Lua_MsgUtil.callFunc("SKILL_UPDATE_DATA", self._data);
end