checkRequire("Lua_FightingResultBaseWindow");
Lua_SuccessWindow = class("Lua_SuccessWindow", Lua_FightingResultBaseWindow)  
function Lua_SuccessWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SuccessWindow";
	self.winTitleAtlas = "ui_zhujiemian_z_tzcg"; -- 挑战成功
	self.tieTitleAtlas = "ui_zhujiemian_z_tzsb"; -- 挑战失败
	self.failTitleAtlas = "ui_zhujiemian_z_tzsb"; -- 挑战失败
end

function Lua_SuccessWindow:buildShowItem()
	self:superCall("buildShowItem");

	local textStr;
	if DataCenter.changeJobData.profession == 4 then
		textStr = LanUtil.getValue(110942);
	else
		textStr = LanUtil.getValue(110927);
	end
	self.tipsSuccess = UICreate.createLabel(self.content, textStr, 0, 3, 500, 30, 30);
	self.tipsSuccess.pivot = UIWidget.Pivot.Center;
	self.tipsSuccess.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.tipsSuccess:setDepth(5);

	self.failResultItem = Lua_FailResultItem.new(self.content);
end

function Lua_SuccessWindow:showWin(param)
	self:superCall("showWin", param);

	if param.result == 0 then -- 失败
		self.failResultItem:setEnable(false);
		self.tipsBg:setLocation(0, -14, 0);
	else
		self.tipsSuccess:setEnable(false);
	end

	local bWin = param.result == 0 and 1 or -1;
	self:setShowInfo(bWin, Lua_ChangeJobUtil.getendtimeConfig());
end

function Lua_SuccessWindow:updateFightingResultBackTime()
	self:superCall("updateFightingResultBackTime");

	if self.backTime > 0 then
		self.backTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(110928), TimeTransform.getInstance():transSeconds1(self.backTime, true));
	end
end

function Lua_SuccessWindow:hide()
	sendMsg(10400902)
	Lua_WindowUtil.openWin("Lua_ChallengeTimeWindow", WinParam.ACTION_CLOSE);
	self:superCall("hide");
end

function Lua_SuccessWindow:dispose()
	if self.tipsSuccess ~= nil then
		self.tipsSuccess:dispose();
		self.tipsSuccess = nil;
	end
	if self.failResultItem ~= nil then
		self.failResultItem:dispose();
		self.failResultItem = nil;
	end
	-- if self.obj ~= nil and IsNil(self.obj) == false then
	-- 	UnityEngine.GameObject.Destroy(self.obj);
	-- 	self.obj = nil;
	-- end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_FailResultItem = class("Lua_FailResultItem", Lua_DisplayObject);
function Lua_FailResultItem:ctor(p)
	self:superCall("ctor", p, "FailResultItem_skin");
end

function Lua_FailResultItem:buildShowItem()
	self:superCall("buildShowItem");

	self.descTxt.text = LanUtil.getValue(110926);

	self.forgingBg:addClickFuntion(self, self.onForgingClick);
	self.rideBg:addClickFuntion(self, self.onRideClick);
	self.petBg:addClickFuntion(self, self.onPetClick);
end

function Lua_FailResultItem:onForgingClick()
	Lua_WindowUtil.openWin("Lua_ForgingWindow");
	Lua_WindowUtil.openWin("Lua_SuccessWindow", WinParam.ACTION_CLOSE)
end

function Lua_FailResultItem:onRideClick()
	Lua_WindowUtil.openWin("Lua_PetWindow", WinParam.ACTION_OPEN);
	Lua_WindowUtil.openWin("Lua_SuccessWindow", WinParam.ACTION_CLOSE)
end

function Lua_FailResultItem:onPetClick()
	Lua_WindowUtil.openWin("Lua_PetWindow", WinParam.ACTION_OPEN, {openIdx = 3});
	Lua_WindowUtil.openWin("Lua_SuccessWindow", WinParam.ACTION_CLOSE)
end

function Lua_FailResultItem:dispose()
	self:superCall("dispose");
end