checkRequire("Lua_WingUtil");
checkRequire("Lua_FasionParamItem");
Lua_WearWingTipsWindow = class("Lua_WearWingTipsWindow", Lua_Window);
function Lua_WearWingTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_WearWingTipsWindow";
	self.skinName = "WearWingTipsWindow_skin";
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_WearWingTipsWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	local data = Lua_ToolVo.new(DataCenter.GodWingData.wear_wing_id);
	data.wingColor = DataCenter.GodWingData.wear_wing_color;
	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(10);
	self.itemImg:setCanClick(false);
	self.itemImg:setLocation(-150, 180, 0);
	self.itemImg.data = data;
	
	local bgStrDic = {"ui_common_tips_02_lv","ui_common_tips_02_lan","ui_common_tips_02_zi","ui_common_tips_02_huang","ui_common_tips_02_hong","ui_common_tips_02_fenhong"};
	self.topBg:setAltas("common_atlas_1", bgStrDic[data.color]);
	self.wingNameLab.text = self.itemImg.data.colorName;

	local fight = Lua_FightUtil.caculateConfigForce(DataCenter.GodWingData.wear_wing_attri);
	local wingConfig = Lua_WingUtil.getItemData(DataCenter.GodWingData.wear_wing_id);
	self.fightTxt.text = fight;
	self.zongTxt.text = fight;
	self.lvTxt.text = wingConfig.use_lvl;
	self.desLab.text = wingConfig.des;
	self.jobTxt.text = Lua_ThingDefine.getJobName(wingConfig.career, wingConfig.profession);

	self.damNum.text = string.format("%.2f", tonumber(DataCenter.GodWingData.wear_wing_attri.damage)) .. "%"
	self.damFloatLab:setLocation(self.damNum.mainContent.transform.localPosition.x + self.damNum.width + 17.5, self.damNum.mainContent.transform.localPosition.y, 0);

	local paramItem;
	self.paramItems = Array();
	for i = 1, 4 do
		paramItem = Lua_FasionParamItem.new(self.content);
		paramItem:setLocation(-133, 15 - 30 * (i - 1));
		paramItem:setTxtFontSize(20, 20, 20);
		paramItem:setEnable(false);
		self.paramItems:add(paramItem);
	end

	local lvltxt;
	local attList;
	local damageNum;
	if DataCenter.GodWingData.wear_wing_class == 0 then
		lvltxt = LanUtil.getValue(110714);
		damageNum = Lua_WingUtil.getMaxRange("one_lvl", "damage");
		attList = Lua_WingUtil.getColorRange("one_lvl", 1);
		self:setAttributes("one_lvl", attList, damageNum);
	elseif DataCenter.GodWingData.wear_wing_class == 1 then
		lvltxt = LanUtil.getValue(110715);
		damageNum = Lua_WingUtil.getMaxRange("two_lvl", "damage");
		attList = Lua_WingUtil.getColorRange("two_lvl", 1);
		self:setAttributes("two_lvl", attList, damageNum);
	elseif DataCenter.GodWingData.wear_wing_class == 2 then
		lvltxt = LanUtil.getValue(110716);
		damageNum = Lua_WingUtil.getMaxRange("three_lvl", "damage");
		attList = Lua_WingUtil.getColorRange("three_lvl", 1);
		self:setAttributes("three_lvl", attList, damageNum);
	elseif DataCenter.GodWingData.wear_wing_class == 3 then
		lvltxt = LanUtil.getValue(110717);
		damageNum = Lua_WingUtil.getMaxRange("four_lvl", "damage");
		attList = Lua_WingUtil.getColorRange("four_lvl", 1);
		self:setAttributes("four_lvl", attList, damageNum);
	elseif DataCenter.GodWingData.wear_wing_class == 4 then
		lvltxt = LanUtil.getValue(110757);
		damageNum = Lua_WingUtil.getMaxRange("five_lvl", "damage");
		attList = Lua_WingUtil.getColorRange("five_lvl", 1);
		self:setAttributes("five_lvl", attList, damageNum);
	end
	local attRange = string.format("%.2f", attList[1]) .. "%" .. "～" .. string.format("%.2f", damageNum) .. "%";
	self.damFloatLab.text = "[" .. attRange .. "]";
	self.regionTxt.text = lvltxt;

	if DataCenter.GodWingData.wear_wing_zizhi == 100 then
		self.damFloatLab:setEnable(false);
	end

	self.refineBtn:addClickFuntion(self, self.onOpenWingRefineWindow);
	self.unloadBtn:addClickFuntion(self, self.onUnloadWing);
end

function Lua_WearWingTipsWindow:onOpenWingRefineWindow()
	Lua_WindowUtil.openWin("Lua_PackWindow", WinParam.ACTION_CLOSE, nil);
	Lua_WindowUtil.openWin("Lua_FeatureMainWindow", WinParam.ACTION_OPEN, 3);
	self:hide();
end

function Lua_WearWingTipsWindow:onUnloadWing()
	sendMsg(11403815);
	self:hide();
end

function Lua_WearWingTipsWindow:setAttributes(str, attList, damageNum)
	local index = 1;
	for i, v in ipairs(Lua_ThingDefine.params) do
		local paramObj = Lua_WingUtil.getMaxRange(str, v);
		if paramObj ~= nil and self.paramItems[index] ~= nil and v ~= "damage" then
			local minNum = math.floor((attList[1] / damageNum) * paramObj);
			local maxNum = math.floor(paramObj);
			local numRange = "[" .. minNum .. "～" .. maxNum .. "]";
			self.paramItems[index]:setEnable(true);
			if DataCenter.GodWingData.wear_wing_zizhi ~= 100 then
				self.paramItems[index]:setWingData(v, DataCenter.GodWingData.attributesList[v], numRange);
			else
				self.paramItems[index]:setWingData(v, DataCenter.GodWingData.attributesList[v], nil);
			end
			index = index + 1;
		end
	end
end