checkRequire("Lua_PropertyParamItem");
Lua_PropertyDetailWindow = class("Lua_PropertyDetailWindow", Lua_Window);
function Lua_PropertyDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PropertyDetailWindow";
	self.skinName = "PropertyDetailWindow_skin";
	self.showBg = false;
	self.showClose = false;
	self.isModel = false;
end

function Lua_PropertyDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 474, 490));
	self.dragContainer:setLocation(270, 19, 0);
	self.dragContainer.uiPanel.depth = 3000;
	self.draggableDetailPanel = Lua_DetailPanel.new(self.dragContainer);
	LuaUtil.updateWindowDepth(nil);

	self.returnBtn:addClickFuntion(self, self.hide)
end

function Lua_PropertyDetailWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	Lua_MsgUtil.callFunc("SHOWORCLOSE_BTN", true);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_DetailPanel = class("Lua_DetailPanel", Lua_DragContainerItem);
function Lua_DetailPanel:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub, "DetailItemPanel_skin");

	dragContainer:addSubContainer(self, true);
end

function Lua_DetailPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.list = Array();
	self.paramList = Array();
	
	self.paramList:add({paramName = "damage", paramLan = 150001, isPercent = true});--伤害加深
	self.paramList:add({paramName = "reduction", paramLan = 150002, isPercent = true});--伤害减免
	self.paramList:add({paramName = "heart_rate", paramLan = 150003, isPercent = true});--会心几率
	self.paramList:add({paramName = "crit_hurt", paramLan = 150004, isPercent = true});--暴击伤害
	self.paramList:add({paramName = "reduce_contral", paramLan = 150005, isPercent = true});--控制抵抗
	self.paramList:add({paramName = "attack_blood", paramLan = 150006, isPercent = true});--攻击回血
	self.paramList:add({paramName = "felement_attack", paramLan = 150007, isPercent = false});--元素攻击
	self.paramList:add({paramName = "felement_defence", paramLan = 150008, isPercent = false});--元素防御
	self.paramList:add({paramName = "pvp_damage", paramLan = 150009, isPercent = true});--PVP伤害增加
	self.paramList:add({paramName = "pvp_reduction", paramLan = 150010, isPercent = true});--PVP伤害减少
	self.paramList:add({paramName = "speed_multi", paramLan = 150011, isPercent = true});--移动速度
	self.paramList:add({paramName = "beast_damage", paramLan = 150012, isPercent = true});--宠物伤害
	self.paramList:add({paramName = "skill_hurt_val", paramLan = 150013, isPercent = true});--技能伤害
	self.paramList:add({paramName = "reverse", paramLan = 150014, isPercent = true});--伤害反射
	self.paramList:add({paramName = "ignore_defence", paramLan = 150015, isPercent = true});--无视防御
	self.paramList:add({paramName = "real_hurt", paramLan = 150016, isPercent = true});--真实伤害
	self.paramList:add({paramName = "block_hurt_rate", paramLan = 150017, isPercent = true});--格挡
	self.paramList:add({paramName = "thump_rate", paramLan = 150018, isPercent = true});--重击
	self.paramList:add({paramName = "double_hit_rate", paramLan = 150019, isPercent = true});--连击
	self.paramList:add({paramName = "reduce_defence", paramLan = 150020, isPercent = false});--破甲
	self.paramList:add({paramName = "extra_crit_rate", paramLan = 150021, isPercent = true});--额外暴击
	self.paramList:add({paramName = "extra_toughness_rate", paramLan = 150022, isPercent = true});--额外韧性
	self.paramList:add({paramName = "absolutely_attack", paramLan = 150023, isPercent = false});--额外攻击
	self.paramList:add({paramName = "absolutely_defence", paramLan = 150024, isPercent = false});--额外防御
	self.paramList:add({paramName = "extra_avoid_rate", paramLan = 150025, isPercent = true});--额外闪避
	self.paramList:add({paramName = "skill_reduction_multi", paramLan = 150026, isPercent = true});--技能伤害减免
	self.paramList:add({paramName = "extra_hit_rate", paramLan = 150027, isPercent = true});--额外命中

	local posX;
	local posY;
	local item;
	for i = 1, self.paramList:getSize() do
		posX = (i - 1) % 2;
		posY = math.floor((i - 1) / 2);

		item = Lua_PropertyParamItem.new(self.content);
		item:setLocation(-222 + 237 * posX, 20 - posY * 40, 0);
		self.list:add(item);
	end
	self:onProperUpdate();

	self:addLuaEvent("ROLE_DATA_CHANGE", self,self.onProperUpdate);
end

function Lua_DetailPanel:onProperUpdate()
	local roleData = DataCenter.roleData;
	self.attTxt.text = math.floor(roleData.attack); -- 攻击
	self.defTxt.text = math.floor(roleData.defence); -- 防御
	self.minTxt.text = math.floor(roleData.hit); -- 命中
	self.shanTxt.text = math.floor(roleData.dodge); -- 闪避
	self.criTxt.text = math.floor(roleData.crit); -- 暴击
	self.renTxt.text = math.floor(roleData.toughness); -- 韧性

	for i = 1, self.paramList:getSize() do
		self.list[i]:setData(self.paramList[i], roleData[self.paramList[i].paramName]);
	end
end

function Lua_DetailPanel:getHeight()
	return 500 + 273;
end