checkRequire("Lua_PropertyDesItem");
Lua_PropertyIllustrationWindow = class("Lua_PropertyIllustrationWindow", Lua_Window);
function Lua_PropertyIllustrationWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PropertyIllustrationWindow";
	self.skinName = "PropertyIllustrationPanel_skin";
	self.isModel = false;
	self.showClose = false;
end

function Lua_PropertyIllustrationWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 474, 450));
	self.dragContainer:setLocation(271, -2, 0);
	self.dragContainer.uiPanel.depth = 3000;
	self.draggablePropertyInfo = Lua_PropertyInfoPanel.new(self.dragContainer);
	self.dragContainer:updateChildPos();
	LuaUtil.updateWindowDepth(nil);

	self.returnBtn:addClickFuntion(self, self.hide)
end

function Lua_PropertyIllustrationWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	Lua_MsgUtil.callFunc("SHOWORCLOSE_BTN", true);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_PropertyInfoPanel = class("Lua_PropertyInfoPanel", Lua_DragContainerItem);
function Lua_PropertyInfoPanel:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);
	dragContainer:addSubContainer(self,true);
end

function Lua_PropertyInfoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.paramList = Array();
	self.paramList:add({paramLan = 110839, desLan = 110300});
	self.paramList:add({paramLan = 107487, desLan = 110301});
	self.paramList:add({paramLan = 110840, desLan = 110302});
	self.paramList:add({paramLan = 110841, desLan = 110303});
	self.paramList:add({paramLan = 110843, desLan = 110304});
	self.paramList:add({paramLan = 110844, desLan = 110305});
	self.paramList:add({paramLan = 110842, desLan = 110306});
	self.paramList:add({paramLan = 110845, desLan = 110307});

	self.paramList:add({paramLan = 150001, desLan = 110309});
	self.paramList:add({paramLan = 150002, desLan = 110310});
	self.paramList:add({paramLan = 150003, desLan = 110311});
	self.paramList:add({paramLan = 150004, desLan = 110312});
	self.paramList:add({paramLan = 150005, desLan = 110313});
	self.paramList:add({paramLan = 150006, desLan = 110314});
	self.paramList:add({paramLan = 150007, desLan = 110315});
	self.paramList:add({paramLan = 150008, desLan = 110316});
	self.paramList:add({paramLan = 150009, desLan = 110317});
	self.paramList:add({paramLan = 150010, desLan = 110318});
	self.paramList:add({paramLan = 150011, desLan = 110319});
	self.paramList:add({paramLan = 150012, desLan = 110320});
	self.paramList:add({paramLan = 150013, desLan = 110321});
	self.paramList:add({paramLan = 150014, desLan = 110322});
	self.paramList:add({paramLan = 150015, desLan = 110323});
	self.paramList:add({paramLan = 150016, desLan = 110324});
	self.paramList:add({paramLan = 150017, desLan = 110325});
	self.paramList:add({paramLan = 150018, desLan = 110326});
	self.paramList:add({paramLan = 150019, desLan = 110327});
	self.paramList:add({paramLan = 150020, desLan = 110330});
	self.paramList:add({paramLan = 150021, desLan = 110331});
	self.paramList:add({paramLan = 150022, desLan = 110332});
	self.paramList:add({paramLan = 150023, desLan = 110333});
	self.paramList:add({paramLan = 150024, desLan = 110334});
	self.paramList:add({paramLan = 150025, desLan = 110335});
	self.paramList:add({paramLan = 150026, desLan = 110336});
	self.paramList:add({paramLan = 150027, desLan = 110337});

	local item;
	local pos = 220;
	self.list = Array();
	for i = 1, self.paramList:getSize() do
		item = Lua_PropertyDesItem.new(self.content);
		item:setData(self.paramList[i]);
		item:setLocation(-210, pos, 0);
		pos = pos - item:getHeight() - 10;
		self.list:add(item);
	end
end

function Lua_PropertyInfoPanel:getHeight()
	return 460 + 890;
end

function Lua_PropertyInfoPanel:dispose()
	if self.paramList ~= nil then
		self.paramList:dispose();
		self.paramList:clear();
		self.paramList = nil;
	end
	if self.list ~= nil then
		self.list:dispose();
		self.list:clear();
		self.list = nil;
	end

	self:superCall("dispose");
end