Lua_PropertyParamItem = class("Lua_PropertyParamItem", Lua_DisplayObject);
function Lua_PropertyParamItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_PropertyParamItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showItem = Lua_ShowItem.new(self.content);
	self.showItem.isWords = true;
	self.showItem.isNum = true;
	self.showItem.wordsFontSize = 22;
	self.showItem.numFontSize = 22;
end

function Lua_PropertyParamItem:setData(obj, value)
	local showValue = obj.isPercent == true and self:showPercent(value) or self:showInt(value);
	self.showItem:setData({wordsStr = LanUtil.getValue(obj.paramLan) .." ：", numStr = showValue, wordsColor = "85A8BE"});
end

function Lua_PropertyParamItem:showPercent(val)
	if val == nil then
		return "0%";
	end
    return LanUtil.formateStr(LanUtil.getValue(110308), tostring(val));
end

function Lua_PropertyParamItem:showInt(val)
	if val == nil then
		return "0";
	end
    local v = math.floor(val);
    return tostring(v);
end

function Lua_PropertyParamItem:dispose()
	if self.showItem ~= nil then
		self.showItem:dispose();
		self.showItem = nil;
	end
	self:superCall("dispose");
end