Lua_AchievementCellItem = class("Lua_AchievementCellItem", Lua_ListCell);
function Lua_AchievementCellItem:ctor(p)
	self:superCall("ctor", p, "AchievementCellItem_skin");
end

function Lua_AchievementCellItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem:setDepth(5);
	self.rewardItem:setClickWin(true);

	self.getBtn:addClickFuntion(self,self.onGotoClick);
end

function Lua_AchievementCellItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.nameTxt.text = data.name;
	self.desTxt.text = data.content;
	self.rewardItem:setRewardByRewardList(Array(data.reward));

	if self.data.show_pro == 1 then
		if data.ach_index == 901000 then
			local expNum = tonumber(tostring(DataCenter.achieveData.exp));
			if expNum > data.need_amount then
				self.infoTxt.text = "("..data.need_amount.."/"..data.need_amount..")";
			else
				self.infoTxt.text = "("..expNum.."/"..data.need_amount..")";
			end
		else
			if data.finish_num == nil then
				self.infoTxt.text = "(0/"..Lua_CommonUtil.getNumberTrans(data.need_amount)..")";
			else
				local finish_num = tonumber(tostring(data.finish_num));
				if finish_num > data.need_amount then
					self.infoTxt.text = "("..Lua_CommonUtil.getNumberTrans(data.need_amount).."/"..Lua_CommonUtil.getNumberTrans(data.need_amount)..")";
				else
					self.infoTxt.text = "("..Lua_CommonUtil.getNumberTrans(finish_num).."/"..Lua_CommonUtil.getNumberTrans(data.need_amount)..")";
				end
			end
		end
	else
		self.infoTxt.text = "";
	end

	-- 0 未完成，1 可领奖，2 已领奖
	if data.status == 2 then
		self.showTipsIcon:setAltas("common_atlas_1", "ui_common_b_");
	elseif data.status == 0 then
		self.showTipsIcon:setAltas("common_atlas_1", "ui_common_wwc");
	end
	self.showTipsIcon:setEnable(data.status ~= 1);
	self.getBtn:setEnable(data.status == 1);
	self:showRedDot(data.status == 1);
end

function Lua_AchievementCellItem:onGotoClick(go)
	if self.data.status ~= 1 then
		OperateAlert.show(LanUtil.getValue(110031));
		return;
	end

	local cmd = ProtoPublic_pb.Proto11401102();
	cmd.ach_index = self.data.ach_index;
	cmd.achieve_id = self.data.id;
	sendMsg(11401102, cmd);
end

function Lua_AchievementCellItem:showRedDot(val)
	if val == true then
		if self.redDot == nil then
			self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 410, 20, 0, 0);
			self.redDot:setDepth(7);
		end
		self.redDot:setEnable(true);
	else
		if self.redDot ~= nil then
			self.redDot:setEnable(false);
		end
	end
end

function Lua_AchievementCellItem:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self.data = nil;
	
	self:superCall("dispose");
end