checkRequire("Lua_AchievementCellItem");
Lua_AchievementInfoPanel = class("Lua_AchievementInfoPanel", Lua_DisplayObject);
function Lua_AchievementInfoPanel:ctor(p)
	self:superCall("ctor", p, "AchievementInfoPanel_skin");
end

function Lua_AchievementInfoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 885, 488));
	self.dragList:setLocation(48, 15, 0);
	self.dragList:setListCell(Lua_AchievementCellItem, 125, 885, 1);

	self.getBtn:addClickFuntion(self, self.onOneGetClick);
end

function Lua_AchievementInfoPanel:setData(val)
	self.selectedVal = val;
	self:updateData();
end

function Lua_AchievementInfoPanel:updateData()
	local achData = DataCenter.achieveData;
	self.canGetNum = achData:canGetNum(self.selectedVal);
	self.atxt.text = LanUtil.formateStr(LanUtil.getValue(110035), tostring(self.canGetNum));

	local arr = achData:getAchList(self.selectedVal);
	arr:sort("sort", false);
	self.dragList:setLuaArrayData(arr, false);

	local state = self.canGetNum ~= nil and self.canGetNum <= 0;
	local normalStr = Lua_ColorDefine.transColor("FFFFFF");
	local grayStr = Lua_ColorDefine.transColor("B6B6B6");
	self.getBtn:setMouseEnable(not state);
	self.getBtn:setStyle(not state and 13 or 12);
	self.getBtn.txt.colorStr = not state and normalStr or grayStr;

	self:showRedDot(self.canGetNum ~= nil and self.canGetNum > 0);
end

function Lua_AchievementInfoPanel:onOneGetClick(go)
	if self.canGetNum == nil or self.canGetNum <= 0 then
		OperateAlert.show(LanUtil.getValue(110028));
		return;
	end

	local cmd = ProtoPublic_pb.Proto11401103();
	cmd.ach_index = self.selectedVal;
	sendMsg(11401103, cmd);
end

function Lua_AchievementInfoPanel:showRedDot(val)
	if val == true then
		if self.redDot == nil then
			self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 465, -250, 0, 0);
			self.redDot:setDepth(10);
		end
		self.redDot:setEnable(true);
	else
		if self.redDot ~= nil then
			self.redDot:setEnable(false);
		end
	end
end

function Lua_AchievementMainPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end

	self:superCall("dispose");
end