checkRequire("Lua_AchievementCellItem");
checkRequire("Lua_AchievementProItem");
Lua_AchievementMainPanel = class("Lua_AchievementMainPanel", Lua_DisplayObject);
function Lua_AchievementMainPanel:ctor(p)
	self.defaultType = 901000;
	
	self:superCall("ctor", p, "AchievementMainPanel_skin");
end

function Lua_AchievementMainPanel:buildShowItem()
	self:superCall("buildShowItem");  

	local aData = DataCenter.achieveData;
	local sortList = aData:getSortList();
	self.barList = Array();
	for i = 1, sortList:getSize() do
		local xindex = (i - 1) % 2;
		local yindex = math.floor((i - 1) / 2);

		local item = Lua_AchievementProItem.new(self.content);
		item:setLocation(-388 + xindex * 453, 206 - yindex * 39, 0);
		item:setName(sortList[i].key, sortList[i].name);
		self.barList:add(item);
	end

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 885, 305));
	self.dragList:setLocation(49.5, -76, 0);
	self.dragList:setListCell(Lua_AchievementCellItem, 125, 885, 1);

	self.paramIcon:addClickFuntion(self,self.onParamClick);
	self.getBtn:addClickFuntion(self,self.onOneGetClick);
end

function Lua_AchievementMainPanel:updateData()
	local achData = DataCenter.achieveData;
	local curLv = 0;
	if achData.achLevel == nil then
		self.lvTxt.text = LanUtil.formateStr(LanUtil.getValue(110027), "0");
		self.expBar:setText(tostring(0) .. "/" .. tostring(0));
	    self.expBar:setMaxValue(100);
	    self.expBar:setValue(100);
	    curLv = 1;
	else
		self.lvTxt.text = LanUtil.formateStr(LanUtil.getValue(110027),tostring(achData.achLevel));
		curLv = achData.achLevel;
		curLv = curLv + 1;
	end

	local nextExp = getConfig({"achieve_level", curLv, "need_exp"});
	if nextExp ~= nil and nextExp ~= 0 then
		self.expBar:setText(tostring(achData.exp) .. "/" .. tostring(nextExp));
	    self.expBar:setMaxValue(nextExp);
	    self.expBar:setValue(achData.exp);
	else
		self.expBar:setText("[85A8BE]"..tostring(0) .. "/--[-]");
	    self.expBar:setMaxValue(100);
	    self.expBar:setValue(100);
	end

	for i = 1, self.barList:getSize() do
		local sortVal = self.barList[i].sortVal;
		local c_cur = achData:getChanelAmount(sortVal);
		local c_max = achData:getChanelMax(sortVal);
		self.barList[i]:setData(c_cur, c_max);
	end

	self.canGetNum = achData:canGetNum(0);
	self.atxt.text = LanUtil.formateStr(LanUtil.getValue(110025), tostring(self.canGetNum));

	local arr = achData:getAchList(self.defaultType);
	arr:sort("sort", false);
	self.dragList:setLuaArrayData(arr, false);

	local state = self.canGetNum ~= nil and self.canGetNum <= 0;
	local normalStr = Lua_ColorDefine.transColor("FFFFFF");
	local grayStr = Lua_ColorDefine.transColor("B6B6B6");
	self.getBtn:setMouseEnable(not state);
	self.getBtn:setStyle(not state and 13 or 12);
	self.getBtn.txt.colorStr = not state and normalStr or grayStr;
	
	self:showRedDot(self.canGetNum ~= nil and self.canGetNum > 0);
end

function Lua_AchievementMainPanel:showChanelbar(bar, val)
	local achData = DataCenter.achieveData;
	local c_cur = 0;
	local c_max = 0;
	local s_cur = 0;
	local s_max = 0;

	c_cur = achData:getChanelAmount(val);
	c_max = achData:getChanelMax(val);
	if c_max == 0 then
		s_cur = 100;
		s_max = 100;
	else
		s_cur = c_cur;
		s_max = c_max;
	end
	bar:setText(tostring(c_cur) .. "/"..tostring(c_max));
    bar:setMaxValue(s_max);
    bar:setValue(s_cur);
end

function Lua_AchievementMainPanel:showRedDot(val)
	if val == true then
		if self.redDot == nil then
			self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 465, -250, 0, 0);
			self.redDot:setDepth(10);
		end
		self.redDot:setEnable(true);
	else
		if self.redDot ~= nil then
			self.redDot:setEnable(false);
		end
	end
end

function Lua_AchievementMainPanel:onParamClick(go)
	local achData = DataCenter.achieveData;
	local curLv = 0;
	if achData.achLevel == nil then
		curLv = 0;
	else
		curLv = achData.achLevel;
	end
	if curLv == 0 then
		OperateAlert.show(LanUtil.getValue(110032));
		return;
	end
	Lua_WindowUtil.openWin("Lua_AchievementParamWindow", nil, curLv);
end

function Lua_AchievementMainPanel:onOneGetClick(go)
	local cmd = ProtoPublic_pb.Proto11401103();
	cmd.ach_index = 0;
	sendMsg(11401103, cmd);
end

function Lua_AchievementMainPanel:dispose()
	if self.barList ~= nil then
		self.barList:dispose();
		self.barList:clear();
		self.barList = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end

	self:superCall("dispose");
end