checkRequire("Lua_AchievementMainPanel");
checkRequire("Lua_AchievementInfoPanel");
Lua_AchievementPanel = class("Lua_AchievementPanel", Lua_DisplayObject);
function Lua_AchievementPanel:ctor(p)
	self.aa = "22";
	self:superCall("ctor", p, "AchievementPanel_skin");
end

function Lua_AchievementPanel:buildShowItem()
	self:superCall("buildShowItem");

	local arr = Array();
	arr:add({name = LanUtil.getValue(110019), data = 0});
	
	local aData = DataCenter.achieveData;
	local sortList = aData:getSortList();
	for i = 1, sortList:getSize() do
		arr:add({name = sortList[i].name, sub = aData:getChildList(sortList[i].key)});
	end

	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, -250, 184, 574),
		Vector3(163, 56, 0), Vector3(144, 46), Vector2(0, 0), Vector3(0, 13));
	self.btnList:setMainBtnStyle("common_atlas_1", "ui_common_btn_p6", "ui_common_btn_p5", "D2D8DC", "FFEDDD", 28);
	self.btnList:setSubBtnStyle("common_atlas_1", "ui_common_btn_p9", "ui_common_btn_p8", "92A0DA", "FFFCB7", 24);
	self.btnList:setLocation(-524, 230, 0);
	self.btnList:setData(arr, self, self.onSubClick);
	self.btnList:setMainSlected(1, 1);

	self:addLuaEvent("ACH_UPDATE", self, self.onServerAchUpdate);
	sendMsg(11401101);
end

function Lua_AchievementPanel:onSubClick(val)
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.selectedData = val;

	if val.data == 0 then
		self.curPanel = Lua_AchievementMainPanel.new(self.content);
		self.curPanel:updateData();
	else
		self.curPanel = Lua_AchievementInfoPanel.new(self.content);
		self.curPanel:setData(val.data);
		self.curPanel:updateData();
	end
	
	self:updateSubRedDot();
end

function Lua_AchievementPanel:onServerAchUpdate()
	local achData = DataCenter.achieveData;
	local mainNum = achData:canGetNum(901000);
	self.numDic = {};
	self.numDic[1] = mainNum > 0;

	local list;
	local num;
	local count;
	self.subDic = {};
	for i = 1, #achData.childDic + 1 do
		list = achData:getChildList(i);
		num = 0;
		self.subDic[i + 1] = {};
		if list ~= nil then
			for j = 1, list:getSize() do
				count = achData:canGetNum(list[j].data);
				num = num + count;
				self.subDic[i + 1][j] = count > 0;
			end
			self.numDic[i + 1] = num > 0;
		end
	end
	self.btnList:setRedDot(1, self.numDic);
	self:updateSubRedDot();
	self:onAchUpdate();
end

function Lua_AchievementPanel:updateSubRedDot()
	if self.selectedData == nil then
		return;
	end
	if self.subDic ~= nil and self.subDic[self.selectedData.mainIndex] ~= nil then
		local openDic = self.subDic[self.selectedData.mainIndex];
		self.btnList:setRedDot(2, openDic);
	else
		self.btnList:setRedDot(2, {});
	end
end

function Lua_AchievementPanel:onAchUpdate(msg)
	if self.curPanel ~= nil then
		self.curPanel:updateData();
	end
end

function Lua_AchievementPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	
	self:superCall("dispose");
end