checkRequire("Lua_ChangeJobUtil");
checkRequire("Lua_LeftInfoBaseWindow");
Lua_ChallengeTimeWindow = class("Lua_ChallengeTimeWindow", Lua_LeftInfoBaseWindow)
function Lua_ChallengeTimeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChallengeTimeWindow";
	self.skinName = "ChallengeTimeWindow_skin";
end

function Lua_ChallengeTimeWindow:showWin(param)
	self:superCall("showWin", param);

	self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(110931), tostring(0), tostring(1));

	if DataCenter.changeJobData.profession == 4 then -- 五转BOSS说明和其它不一样
		self.tipsTxt.text = LanUtil.getValue(110943);
	else
		self.tipsTxt.text = LanUtil.getValue(110932);
	end

	local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneCfg ~= nil and sceneCfg.config.name then
		self.titleLab.text = sceneCfg.config.name;
	end

	self.lefttime = math.abs(param.left_time);
	if self.lefttime > 0 then
		Lua_CommonUtil.addTimer("updateFightStartTime", 1, self, self.updateStartTime, nil, -1);
	else
		Lua_CommonUtil.removeTimer(self, self.updateStartTime);
	end

	self:updateWindowDepth();

	self.tipsTxt.clickScale = false;
	self.tipsTxt:addUrlClickFuntion(self,self.checkUrlClick);

	self:addLuaEvent("MENU_OUT_CLICK", self, self.onMenuOutClick);
end

function Lua_ChallengeTimeWindow:updateStartTime()
	if self.lefttime >0 then
		self.lefttime = self.lefttime - 1;
		self.challengeTime.text = LanUtil.formateStr(LanUtil.getValue(110930), TimeTransform.getInstance():transSeconds1(self.lefttime, true));
	else
		Lua_CommonUtil.removeTimer(self, self.updateStartTime);
	end
end

function Lua_ChallengeTimeWindow:onMenuOutClick(o)
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(121635), type = 1, subFun = self.onOutClick});
end

function Lua_ChallengeTimeWindow:onOutClick(val)
	sendMsg(10400902);
	self:hide();
end

function Lua_ChallengeTimeWindow:checkUrlClick(url)
	Lua_ChangeJobUtil.urlClickHandle(url);
end

function Lua_ChallengeTimeWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.updateStartTime);
	self:superCall("dispose");
end