checkRequire("Lua_ChangeJobCell");
checkRequire("Lua_ChangeJobUtil");
Lua_ChangeJobDetailPanel = class("Lua_ChangeJobDetailPanel", Lua_DisplayObject);
function Lua_ChangeJobDetailPanel:ctor(p)
	self:superCall("ctor", p, "ChangeJobDetailPanel_skin");
end

function Lua_ChangeJobDetailPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.stateTxt.text = LanUtil.getValue(110925);
	self.redDot:setEnable(false);

	local expcost = Lua_CommonUtil.getNumberTrans(Lua_ChangeJobUtil.expcostConfig(1));
	local exp = Lua_CommonUtil.getNumberTrans(DataCenter.roleData.exp);
	self.explabel.text = LanUtil.formateStr(LanUtil.getValue(110911), tostring(expcost), tostring(exp));
	self.explabel:setEnable(false);

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setLocation(366, -83, 0);
	self.itemImage:setDepth(5);

	self.cb1.seleted = true;
	self.cb2.seleted = false;
	self.cb1:addBoxChange(self, self.onUseXmBoxClick);
	self.cb2:addBoxChange(self, self.onUseExpBoxClick);

	self:quanCell();

	self:addLuaEvent("ChangeJob_UPDATE", self, self.onUpdataInfo);
	self:addLuaEvent("DETAIL_PANLE", self, self.Extraction);
end

function Lua_ChangeJobDetailPanel:quanCell()
	local info = {
		[1] = {x = -398, y = 162, lineX = -73, lineY = -60, lineRotaZ = -45, lineHeight = 170, nameStr = LanUtil.getValue(110900)};
		[2] = {x = -528, y = 40, lineX = 73, lineY = -38, lineRotaZ = 68, lineHeight = 170, nameStr = LanUtil.getValue(110901)};
		[3] = {x = -388, y = -38, lineX = -57, lineY = -60, lineRotaZ = -47, lineHeight = 170, nameStr = LanUtil.getValue(110902)};
		[4] = {x = -513, y = -156, lineX = 69, lineY = -54, lineRotaZ = 54, lineHeight = 170, nameStr = LanUtil.getValue(110903)};
		[5] = {x = -364, y = -258, lineX = 81, lineY = 48, lineRotaZ = -52, lineHeight = 170, nameStr = LanUtil.getValue(110904)};
		[6] = {x = -211, y = -150, lineX = 94, lineY = -58, lineRotaZ = 53, lineHeight = 170, nameStr = LanUtil.getValue(110905)};
		[7] = {x = -22, y = -265, lineX = 65, lineY = 81, lineRotaZ = -38, lineHeight = 170, nameStr = LanUtil.getValue(110906)};
		[8] = {x = 107, y = -99, lineX = -130, lineY = 72, lineRotaZ = 61, lineHeight = 230, nameStr = LanUtil.getValue(110907)};
		[9] = {x = -135, y = 36, lineX = 75, lineY = 65, lineRotaZ = -53, lineHeight = 170, nameStr = LanUtil.getValue(110908)};
		[10] = {x = 15, y = 162, lineX = -75, lineY = -61, lineRotaZ = -53, lineHeight = 170, nameStr = LanUtil.getValue(110909)};
	}

	local changeJobCell;
	self.quanCellList = Array();
	for i = 1, 10 do
		changeJobCell = Lua_ChangeJobCell.new(self.content);
		changeJobCell.stageLab.text = info[i].nameStr;

		changeJobCell.line:setRot(0, 0, info[i].lineRotaZ);
		changeJobCell.line:setLocation(info[i].lineX, info[i].lineY);
		changeJobCell.line:SetDimensions(10, info[i].lineHeight);

		changeJobCell.completeLine:setRot(0, 0, info[i].lineRotaZ);
		changeJobCell.completeLine:setLocation(info[i].lineX, info[i].lineY);
		changeJobCell.completeLine:SetDimensions(6, info[i].lineHeight);
		
		changeJobCell:setIndex(i);
		changeJobCell:setLocation(info[i].x, info[i].y);
		self.quanCellList:add(changeJobCell);
	end
	self.quanCellList[10].line:setEnable(false);
	self.quanCellList[10].completeLine:setEnable(false);
end

function Lua_ChangeJobDetailPanel:onTipsClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(110924));
end

function Lua_ChangeJobDetailPanel:Extraction(msg)
	-- 10 个阶段，已完成的阶段：msg.obj_value，当前正在做的阶段
	if msg.obj_value + 1 <= 10 then
		for i = 1, msg.obj_value + 1 do -- 已完成   
			self.quanCellList[i].showIcon:setAltas("role_atlas", "ui_figure_xing3");
			self.quanCellList[i].completeLine:setEnable(i < msg.obj_value + 1);
		end
	end

	if msg.complete_task == true then
		self.jihuoBtn.label = LanUtil.getValue(110916); -- 下个阶段
		self.jihuoBtn:removeClickFuntion(self, self.onJihuoClick);
		self.jihuoBtn:addClickFuntion(self, self.onWanChengClick)
	else
		self.jihuoBtn:removeClickFuntion(self, self.onWanChengClick);
		self.jihuoBtn:addClickFuntion(self, self.onJihuoClick)
	end

	local id = Lua_ChangeJobUtil.itemcost(msg.obj_value);
	self.hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(id);
	self.needCost = Lua_ChangeJobUtil.itemcount(msg.obj_value);
	self.itemImage.data = Lua_ToolVo.createToolVo(id, self.hadCount)
	self.itemImage:showNumLimit(self.hadCount, self.needCost, 2);

	self:onUpdataInfo(msg.obj_value);
end

function Lua_ChangeJobDetailPanel:onWanChengClick()
	DataCenter.changeJobData:sOneKeyMsg(false);
end

function Lua_ChangeJobDetailPanel:onUpdataInfo(stageValue)
	local nextValue = stageValue == 10 and stageValue or stageValue + 1;
	self.stageLab.text = self.quanCellList[nextValue].stageLab.text;
	for i = 1, self.quanCellList:getSize() do
		self.quanCellList[i]:setObjState(i == nextValue);
	end

	stageValue = stageValue == 10 and stageValue - 1 or stageValue;
	local blood = Lua_ChangeJobUtil.bloodConfig(nextValue);
	local attack = Lua_ChangeJobUtil.attackConfig(nextValue);
	local crit = Lua_ChangeJobUtil.critConfig(nextValue);
	if stageValue > 0 then
		blood = blood - Lua_ChangeJobUtil.bloodConfig(stageValue);
		attack = attack - Lua_ChangeJobUtil.attackConfig(stageValue);
		crit = crit - Lua_ChangeJobUtil.critConfig(stageValue);
	end
	self.descLab.text =  LanUtil.formateStr(LanUtil.getValue(110910), tostring(blood), tostring(attack), tostring(crit));

	self.expCost = Lua_ChangeJobUtil.expcostConfig(nextValue);
	if self.expCost <= DataCenter.roleData.exp then
		roleExp = "[85A8BE]"..Lua_CommonUtil.getNumberTrans(DataCenter.roleData.exp).."[-]";
	else
		roleExp = "[FF1616]"..Lua_CommonUtil.getNumberTrans(DataCenter.roleData.exp).."[-]";
	end
	self.explabel.text = LanUtil.formateStr(LanUtil.getValue(110941), tostring(roleExp), tostring(Lua_CommonUtil.getNumberTrans(self.expCost)))

	if self.cb1.seleted then
		self.redDot:setEnable(self.hadCount >= self.needCost);
	else
		self.redDot:setEnable(self.expCost <= DataCenter.roleData.exp);
	end
end

function Lua_ChangeJobDetailPanel:onUseXmBoxClick(state)
	self.cb1.seleted = true;
	self.cb2.seleted = false;
	self.itemImage:setEnable(true);
	self.explabel:setEnable(false);
	self.redDot:setEnable(self.hadCount >= self.needCost);
end

function Lua_ChangeJobDetailPanel:onUseExpBoxClick(state)
	self.cb1.seleted = false;
	self.cb2.seleted = true;
	self.itemImage:setEnable(false);
	self.explabel:setEnable(true);
	self.redDot:setEnable(self.expCost <= DataCenter.roleData.exp);
end

function Lua_ChangeJobDetailPanel:onJihuoClick(go)
	if self.cb1.seleted == true then
		DataCenter.changeJobData:sActivateMsg(false)
	end

	if self.cb2.seleted == true then
		DataCenter.changeJobData:sActivateMsg(true)
	end
end

function Lua_ChangeJobDetailPanel:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end

	self:superCall("dispose");
end