checkRequire("Lua_ChangeJobUtil");
checkRequire("Lua_ChangeJobVo");
Lua_ChangeJobPanel = class("Lua_ChangeJobPanel", Lua_DisplayObject);
function Lua_ChangeJobPanel:ctor(p)
	self:superCall("ctor", p, "ChangeJobPanel_skin");

	self.showModel = true;
end

function Lua_ChangeJobPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsobj:SetActive(false);
	self.tipObj:SetActive(false);
	self.label:setEnable(false);

	self.model = Lua_MyPlayerModel.new(self.content, self.oldJobTxt);
	self.model:setLocation(-307, -238, 150);

	self.skillbg = UICreate.createUIAtlasImage(self.skillobj, "iconantlas1", "tongyong_skill_circle", 330, -45, 80, 80);
	self.skillbg.name = "skillbg";
	self.skillbg:setDepth(3);
	self.skillbg:setSacle(0.9, 0.9, 0.9);

	self.skill = UICreate.createUIAtlasImage(self.skillobj, "skillIcon_atlas_1", "4004", 330, -45, 70, 70);
	self.skill.clickScale = false;
	self.skill.name = "skill";
	self.skill:setDepth(4);
	self.skill:addClickFuntion(self,self.onTipsClick);
	self.skill:setSacle(0.9, 0.9, 0.9);

	self.oneBtn:addClickFuntion(self, self.onOneClick); -- 一键完成
	
	self:extractionMsg();

	self:addLuaEvent("EXTRACTION_UPDATE", self, self.extractionMsg);
	self:addLuaEvent("SHOW_JOBUPDATA", self, self.onGoClick);
end

function Lua_ChangeJobPanel:extractionMsg()
	local changeJobData =  DataCenter.changeJobData;
	self.money = changeJobData.money;
	self.taskStep = changeJobData.taskStep;
	self.oldJobTxt.text = changeJobData.professionName;
	self.newJobTxt.text = changeJobData.nextprofessionName;
	self.oldTimeTxt.text = changeJobData.profession;
	self.newTimeTxt.text = changeJobData.nextprofession;

	local posX = self.oldJobTxt.mainContent.transform.localPosition.x + self.oldJobTxt.width + 11;
	self.arrowSp0:setLocation(posX, 200, 0);

	posX = self.arrowSp0.mainContent.transform.localPosition.x + self.arrowSp0.width + 18;
	self.newJobTxt:setLocation(posX, 200, 0);

	self.paramAddTxt.text =  Lua_ChangeJobUtil.getproperty(changeJobData.profession);
	self.attAddTxt.text = Lua_ChangeJobUtil.getskill(changeJobData.profession);
	self.jobAddTxt.text = Lua_ChangeJobUtil.getadorn(changeJobData.profession);

	self.skillid = Lua_ChangeJobUtil.getskillid(DataCenter.roleData.career, changeJobData.profession);
	if self.skillid ~= 0 then
		self.skillVo = Lua_SkillVo.new(self.skillid);
		self.skilldata = Lua_ChangeJobVo.new(self.skillid);
		self.skill:setAltas(tostring(self.skilldata.atlas), tostring(self.skillVo.skillIcon));
	end

	local level = Lua_ChangeJobUtil.getlevel(changeJobData.profession);
	self.tips.text = LanUtil.formateStr(LanUtil.getValue(110915), tostring(level), tostring(level - DataCenter.roleData.level), tostring(changeJobData.nextprofession));	
	self.tParamLabel.text = Lua_ChangeJobUtil.nameConfig(changeJobData.profession,changeJobData.taskStep);

	if changeJobData.isProfession == true then
		self.goBtn.label = LanUtil.getValue(110919); -- 转职
		self.goBtn:removeClickFuntion(self, self.onSubClick);
		self.goBtn:removeClickFuntion(self, self.onQianWangClick);
		self.goBtn:addClickFuntion(self, self.onGoClick);
	elseif changeJobData.completeTask == true then 
		self.goBtn.label = LanUtil.getValue(110916); -- 下个阶段
		self.goBtn:addClickFuntion(self, self.onSubClick);
		self.goBtn:removeClickFuntion(self, self.onGoClick);
		self.goBtn:removeClickFuntion(self, self.onQianWangClick);
	else
		self.goBtn.label = LanUtil.getValue(110917); -- 前往
		self.goBtn:removeClickFuntion(self, self.onSubClick);
		self.goBtn:removeClickFuntion(self, self.onGoClick);
		self.goBtn:addClickFuntion(self, self.onQianWangClick);
	end

	self.Obj:SetActive(changeJobData.openTask);
	self.tipObj:SetActive(not changeJobData.openTask);
	self.skillobj:SetActive(self.skillid ~= 0);
	self.tipskill:setEnable(self.skillid == 0);
	self.oneBtn:setEnable(changeJobData.onebtnShow == 1);
	self.oneBtn:setStyle(not changeJobData.completeTask and 13 or 12);
	self.oneBtn:setMouseEnable(not changeJobData.completeTask);
	self.redDot:setEnable(changeJobData.isProfession == true or changeJobData.completeTask == true);

	if changeJobData.openTask == true then
		self.jobdataId = changeJobData.jobdata[1].objId;
		self.taskTxt.text = changeJobData.professiontaskShow;
	else
		self.redDot:setEnable(false);
	end

	if changeJobData.isShow == true then -- 转职阶段全部完成
		self:noProfession();
	end
end

-- 转职任务完成显示的界面
function Lua_ChangeJobPanel:noProfession()
	self.Obj:SetActive(false);
	self.redDot:setEnable(false);
	self.zhuanshiSp4:setEnable(false);
	self.label:setEnable(true);
	self.tipObj:SetActive(false);
	self.skillobj:SetActive(false);
	self.tipsobj:SetActive(true);
	self.rightObj:SetActive(true);

	if self.ChangeJobDetailPanel ~= nil then
		self.ChangeJobDetailPanel:dispose();
		self.ChangeJobDetailPanel = nil;
	end

	if self.model ~= nil then
		self.model:dispose();
		self.model = nil;
	end
end

function Lua_ChangeJobPanel:onTipsClick()
	local data = {}
	data.name = self.skilldata.name;
	data.limittype = self.skilldata.limittype;
	data.atlas = self.skilldata.atlas;
	data.time = self.skilldata.time;
	data.id = self.skillVo.skillIcon;
	data.tips = self.skilldata.tips;
	data.nexttips = self.skilldata.nexttips;
	data.unseal = self.skilldata.unseal;
	Lua_WindowUtil.openWin("Lua_SkillTipsWindow",WinParam.ACTION_OPEN,data);
end

-- function Lua_ChangeJobPanel:onImage(go)
-- 	self.itemImage= Lua_ToolImage.new(self.content);
-- 	self.itemImage:setLocation(260, -110, 0);
-- 	self.itemImage:setDepth(5);
-- end

function Lua_ChangeJobPanel:onOneClick(go)
	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(110918), tostring(self.money));  
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.onSubCallback; -- 确定
	--tipData.cancelFun = self.onSubClick; -- 取消
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_ChangeJobPanel:onQianWangClick()
	DataCenter.changeJobData:onQianWangClick();
end

function Lua_ChangeJobPanel:onSceneLoaded()
	Lua_WindowUtil.openWin("Lua_RoleMainWindow", WinParam.ACTION_CLOSE);
	DataCenter.hook:start();
end

function Lua_ChangeJobPanel:onSubClick()
	DataCenter.changeJobData:sOneKeyMsg(false);
end

function Lua_ChangeJobPanel:onSubCallback()
	Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_CLOSE);
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD,self.money,true,true) == false then	
		return;
	end
	DataCenter.changeJobData:sOneKeyMsg(true);
	-- DataCenter.changeJobData:sExtractionMsg();
end

function Lua_ChangeJobPanel:onGoClick(go)
	DataCenter.changeJobData:sJobMsg();

	local data = {};
	local blood = Lua_ChangeJobUtil.bloodpropConfig(tonumber(self.newTimeTxt.text));
	local attack = Lua_ChangeJobUtil.attackpropConfig(tonumber(self.newTimeTxt.text));
	local defence = Lua_ChangeJobUtil.defencepropConfig(tonumber(self.newTimeTxt.text)); 
	data.blood = blood;
	data.attack = attack;
	data.defence = defence;
	data.title = LanUtil.formateStr(LanUtil.getValue(110922),tostring(self.newTimeTxt.text),tostring(self.newJobTxt.text));
	data.skilltips = Lua_ChangeJobUtil.getskillcg(tonumber(self.newTimeTxt.text));
	data.adorn = Lua_ChangeJobUtil.getadorncg(tonumber(self.newTimeTxt.text));
	if self.skillid ~= 0 then
		data.id = self.skillVo.skillIcon;
	end
	Lua_WindowUtil.openWin("Lua_ChageJobSuccessWindow",WinParam.ACTION_OPEN, data);
end

-- function Lua_ChangeJobPanel:setBlackMaskFun(val)
-- 	if self.playerModel ~= nil then
-- 		self.playerModel:setActive(val);
-- 	end
-- 	self.showModel = val;
-- end

function Lua_ChangeJobPanel:dispose()
	if self.skillbg ~= nil then
		self.skillbg:dispose();
		self.skillbg = nil;
	end
	if self.skill ~= nil then
		self.skill:dispose();
		self.skill = nil;
	end
	if self.model ~= nil then
		self.model:dispose();
		self.model = nil;
	end
	self:superCall("dispose");
end