checkRequire("Lua_ChangeJobUtil");
Lua_UseStuffWindow = class("Lua_UseStuffWindow", Lua_Window);
function Lua_UseStuffWindow:ctor()	
	self:superCall("ctor");

	self.windowName = "Lua_UseStuffWindow";
	self.skinName = "UseStuffWindow_skin";
	self.isClickClose = true;
end

function Lua_UseStuffWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setDepth(6);
	self.itemImage:setEnable(false);
	self.itemImage:setLocation(0, -25, 0);

	self.useStuffBox:addBoxChange(self, self.onUseStuffBoxClick);
	self.useExpBox:addBoxChange(self, self.onUseExpBoxClick);
	self.subBtn:addClickFuntion(self, self.onSubClick);

	self:onUseStuffBoxClick();

	self:addLuaEvent("EXTRACTION_UPDATE", self, self.showContent);
end

function Lua_UseStuffWindow:showWin(param)
	self:superCall("showWin", param);

	self.taskvalue = tonumber(param);
	self:showContent();
end

function Lua_UseStuffWindow:showContent()
	local clientShow = Lua_ChangeJobUtil.clientShow();
	local stage = DataCenter.changeJobData.stage;
	self.titleLab.text = clientShow[stage];

	self.dragonBall = Lua_ChangeJobUtil.dragonBall();
	local taskvalue = DataCenter.changeJobData.taskvalue;
	taskvalue = taskvalue >= 7 and taskvalue or taskvalue + 1;
	if self.taskvalue ~= nil and self.taskvalue <= DataCenter.changeJobData.taskvalue then 
		taskvalue = self.taskvalue;
		self.subBtn:setBtnEnable(false);
		self.subBtn.label = LanUtil.getValue(122316);
	end
	self.properyTex.text = Lua_ChangeJobUtil.fiveProto(stage, taskvalue);

	self.needExp = self.dragonBall[stage].exp_cost[taskvalue];
	local colorStr = DataCenter.roleData.exp >= self.needExp and "[85A8BE]" or "[FF1616]";
	local roleExp = colorStr..Lua_CommonUtil.getNumberTrans(DataCenter.roleData.exp).."[-]";
	local expCost = Lua_CommonUtil.getNumberTrans(self.needExp);
	self.roleExpTex.text = LanUtil.formateStr(LanUtil.getValue(110941), tostring(roleExp), tostring(expCost));
	self.roleExpTex:setEnable(self.useExpBox.seleted);

	self.item = self.dragonBall[stage].item_cost[taskvalue];
	self.haveItem = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.item[1]);
	self.itemImage.data = Lua_ToolVo.new(self.item[1], 1, 0);
	self.itemImage:showNumLimit(self.haveItem, self.item[2], 2);
	self.itemImage:setEnable(self.useStuffBox.seleted);
	self.useStuffBox.label = LanUtil.getValue(110822) .. self.itemImage.data.name;
end

function Lua_UseStuffWindow:onUseStuffBoxClick()
	self.useExpBox.seleted = false;
	self.useStuffBox.seleted = true;
	self:showContent();
end

function Lua_UseStuffWindow:onUseExpBoxClick()
	self.useExpBox.seleted = true;
	self.useStuffBox.seleted = false;
	self:showContent();
end

function Lua_UseStuffWindow:onSubClick()
	if self.useStuffBox.seleted == true then
		if DataCenter.packData:getBagType(2):getItemNum(self.item[1]) < self.item[2] then
			local arr = Array();
			arr:add(Lua_ToolVo.new(self.item[1], 1, 1));
			Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
		end
	else
		if DataCenter.roleData.exp < self.needExp then
			local arr = Array();
			arr:add(Lua_ToolVo.new(Lua_MoneyData.EXP, 1, 1));
			Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
		end
	end

	local cmd = ProtoPublic_pb.Proto11403907();
	cmd.exp_dragon = self.useExpBox.seleted;
	sendMsg(11403907, cmd);
end