checkRequire("Lua_FasionParamItem");
Lua_FashionAttributeWindow = class("Lua_FashionAttributeWindow", Lua_Window);
function Lua_FashionAttributeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FashionAttributeWindow";
	self.skinName = "FashionAttributeWindow_skin";
	self.blackAlpha = 1 / 255;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_FashionAttributeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 308, 286));
	self.dragContainer:setLocation(207, -45, 0);

	local list = {}; -- 百分比加成 标识
	local multiList = {"damage_multi", "reduction_multi", "attack_multi", "defence_multi", "blood_multi"};
    if multiList ~= nil then
	    for i,v in ipairs(multiList) do
	        list[v] = 1;
	    end
	end

	local index = 1;
	local str;
	local item;
	local totalFight = 0;
	for i,v in ipairs(Lua_ThingDefine.params) do
		local oneTotalAttri = 0;
		for k,p in pairs(DataCenter.FashionData.fashion_infoList) do -- 时装、头饰、武器、相框、气泡
			local paramObj = Lua_FashionUtil.getAttConfig(p.itemId, v);
			if paramObj ~= nil and p.level ~= 0 then
				oneTotalAttri = oneTotalAttri + paramObj[p.level]
		    end
		end

		if DataCenter.FashionData.acti_suit_list ~= nil then
			for j,m in pairs(DataCenter.FashionData.acti_suit_list) do -- 套装
				local val = getConfig({"suit", m, tostring(v)});
				if val ~= nil then
					oneTotalAttri = oneTotalAttri + val[1];
				end
			end
		end

		if oneTotalAttri ~= 0 then
			local str = list[v] == 1 and oneTotalAttri .. "%" or oneTotalAttri;
			item = Lua_FasionParamItem.new(self.dragContainer.content);
			item:setTransForm(-154, 132, 0); -- 308 / 2, 286 / 2 - text.height / 2
			item:setHeight(34);
			item:setData(v, str, nil, "AttributeWindow");
			self.dragContainer:addSubContainer(item, true);
			
			index = index + 1;
			totalFight = totalFight + Lua_FightUtil.caculateConfigForce({v = oneTotalAttri});
		end
	end
	self.dragContainer.canDrag = index > 9;

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 19;
	self.fightNum.prefix = "a_";
	self.fightNum.num = totalFight;
	self.fightNum:setNumScale(0.8, 0.8);
	self.fightNum:setDepth(5);
	self.fightNum:setLocation(123, 141.5, 0);

	self.attributeTxt.text = LanUtil.formateStr(LanUtil.getValue(110358), tostring(totalFight));
	self.attributeTxt:setEnable(false);
end