checkRequire("Lua_FasionInsidePanel");
checkRequire("Lua_MyPlayerModel");
Lua_FasionBgPanel = class("Lua_FasionBgPanel", Lua_FasionInsidePanel);
function Lua_FasionBgPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FasionBgPanel:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FasionBgPanel:updateFashionModel()
	self.roleBg:setUrl("/images/fashionBg/fashion_"..self.selectedData.id..".png");

	if self.effectBg ~= nil then
		self.effectBg:dispose();
		self.effectBg = nil;
	end

	if self.effectBg == nil and self.selectedData.effectName ~= nil then
		local offset = DataCenter.FashionData:getBgEffectOffset(self.selectedData.id, "fashion_offset");
		self.effectBg = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..self.selectedData.effectName, self.selectedData.effectName, offset[1], offset[2]);
		self.effectBg:setScale(offset[4], offset[4], offset[4]);
		self.effectBg:SetRenderQueue(self.roleBg, 10, 2, false);
	end

	if self.playerModel == nil then
		self.playerModel = Lua_MyPlayerModel.new(self.content, self.roleBg);
		self.playerModel:setLocation(-36, -218, -250);
	end
end

function Lua_FasionBgPanel:dispose()
	if self.effectBg ~= nil then
		self.effectBg:dispose();
		self.effectBg = nil;
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	DataCenter.FashionData.fashionBg_id = nil;

	self:superCall("dispose");
end