checkRequire("Lua_MyPlayerModel");
Lua_FasionBgShowWindow = class("Lua_FasionBgShowWindow", Lua_Window);
function Lua_FasionBgShowWindow:ctor()
    self:superCall("ctor");

    self.w = 770;
    self.h = 630;
    self.showClose = true;
    self.showBg = false;
    self.isClickClose = false;
    self.layer = 4500;
    self.windowName = "Lua_FasionBgShowWindow";
end

function Lua_FasionBgShowWindow:buildShowItem()
    self:superCall("buildShowItem");

    if self.btnClose ~= nil then
        self.btnClose:SetDimensions(45, 45);
    end
end

function Lua_FasionBgShowWindow:dispose()
    if self.fashionBg ~= nil then
        self.fashionBg:dispose();
        self.fashionBg = nil;
    end
    if self.playerModel ~= nil then
        self.playerModel:dispose();
        self.playerModel = nil;
    end
    if self.effectBg ~= nil then
        self.effectBg:dispose();
        self.effectBg = nil;
    end
    
    self:superCall("dispose");
end

function Lua_FasionBgShowWindow:showWin(param)
    self:superCall("showWin", param);

    self:updateFashionBgInfo();
end

function Lua_FasionBgShowWindow:updateFashionBgInfo()
    if self.fashionBg ~= nil then
        self.fashionBg:dispose();
        self.fashionBg = nil;
    end
    self.fashionBg = UICreate.createImage(self.content, "/images/fashionBg/fashion_"..self.showData.id..".png", 0, 0, 0, 0);
    self.fashionBg.name = "fashionBg";
    self.fashionBg:setDepth(0);

    if self.effectBg ~= nil then
        self.effectBg:dispose();
        self.effectBg = nil;
    end
    if self.effectBg == nil and self.showData.effectName ~= nil then
        local offset = DataCenter.FashionData:getBgEffectOffset(self.showData.id, "show_offset");
        self.effectBg = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..self.showData.effectName, self.showData.effectName, offset[1], offset[2]);
        self.effectBg:setScale(offset[4], offset[4], offset[4]);
        self.effectBg:SetRenderQueue(self.fashionBg, 10, 2, false);
    end

    if self.playerModel == nil then
        self.playerModel = Lua_MyPlayerModel.new(self.content, self.fashionBg);
        self.playerModel:setLocation(0, -170, -150);
    end
end