checkRequire("Lua_FasionParamItem");
checkRequire("Lua_FasionItem");
Lua_FasionInsidePanel = class("Lua_FasionInsidePanel", Lua_DisplayObject);
function Lua_FasionInsidePanel:ctor(p)
	self:superCall("ctor", p, "FasionPanel_skin");
end

function Lua_FasionInsidePanel:buildShowItem()
	self:superCall("buildShowItem");

	local paramItem;
	local startPosY = 85;
	self.paramItems = Array();
	for i = 1, 5 do
		paramItem = Lua_FasionParamItem.new(self.content);
		paramItem:setLocation(325, startPosY - 30 * (i - 1));
		paramItem:setEnable(false);
		self.paramItems:add(paramItem);
	end

	self.shardImg = Lua_ToolImage.new(self.content);
	self.shardImg:setDepth(5);
	self.shardImg:setLocation(368, -195, 0);
	self.shardImg:setCanClick(true);

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 13;
	self.fightNum.numAtlas = "number_atlas";
	self.fightNum:setDepth(5);
	self.fightNum:setLocation(368, 184, 0);

	self.txtLabel = UICreate.createLabel(self.content, "", 0, 0, 235, 30, 30);
	self.txtLabel.name = "txtLabel";
	self.txtLabel.pivot = UIWidget.Pivot.Center;
	self.txtLabel.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.txtLabel:setDepth(5);
	self.txtLabel:setLocation(368, -190, 0);

	self.fasionDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 544));
	self.fasionDragList:setLocation(-460, -65, 0);
	self.fasionDragList:setListCell(Lua_FasionItem, 106, 286, 1);

	self.jihuoBtn:addClickFuntion(self, self.onJiHuoClick);
	self.chuanBtn:addClickFuntion(self, self.onChuanDaiClick);
	self.shizhuangsp:addClickFuntion(self, self.onShiZhuangSpClick);

	self:addLuaEvent("SKIN_CHILDCELL_CLICK", self, self.onSkinChildCellClick);
end

function Lua_FasionInsidePanel:setData(val)
	if self.curType ~= val then
		self.selectedData = nil;
	end
	self.curType = val;

	if val < 7 then -- 排除套装
		local defaultData = nil;
		local itemList = DataCenter.FashionData:getItemByType(val);
		defaultData = DataCenter.FashionData:getDefaultItem(val);
		if DataCenter.FashionData._id == nil then
			-- 已穿戴的>已激活的>可激活的>无
			if defaultData == nil then
				for i = 1, itemList:getSize() do
					if itemList[i].is_wear == 1 then -- 已穿戴
						defaultData = itemList[i];
						break;
					end
				end
			end

			if defaultData == nil then
				for i = 1, itemList:getSize() do
					if itemList[i].active_type == 1 then -- 已激活
						defaultData = itemList[i];
						break;
					end
				end
			end
			
			if defaultData == nil then
				for i = 1, itemList:getSize() do
					if itemList[i].active_type == 2 then -- 可激活	
						defaultData = itemList[i];
						break;
					end
				end
			end
		else  -- 使用道具直接跳转
			local list = DataCenter.FashionData.getIndex;
			local index = list.item_index;
			if defaultData == nil then
				defaultData = itemList[index];
			end
		end

		if defaultData == nil then
			defaultData = itemList[1];
		end
		self:updateData(defaultData, true);
	end
end

function Lua_FasionInsidePanel:onSkinChildCellClick(val)
	self:updateData(val, false);
end

function Lua_FasionInsidePanel:updateData(defaultData, moveTo)
	local itemList = DataCenter.FashionData:getItemByType(self.curType);
	local len = itemList:getSize();
	local moveToIndex = 1;
	for i = 1, len do
		local vo = itemList[i];
		if vo.id == defaultData.id then
			moveToIndex = i;
			itemList[i].select = true;
		else
			itemList[i].select = false;
		end
	end

	self:showFashionData(defaultData);
	self.fasionDragList:setLuaArrayData(itemList, false);
	if moveTo == true then
		self.fasionDragList:moveToIndex(moveToIndex, true);
	end
end

function Lua_FasionInsidePanel:showFashionData(defaultData)
	self.selectedData = defaultData;
	DataCenter.FashionData:setDefaultItem(self.curType, defaultData);
	local maxLv = Lua_FashionUtil.getFasionMaxLevel(self.selectedData.itemId);

	if Lua_FashionUtil.getInterfaceType(defaultData.itemId) == 1 then
		self.interfaceTxt:setEnable(false);
		self.interfaceTxt.text = "[活動獲得]";
	else
		self.interfaceTxt:setEnable(true);
		self.interfaceTxt.text = Lua_FashionUtil.getInterfaceConfig(defaultData.itemId);
	end

	local shard = Lua_FashionVo.new(self.selectedData.itemId);
	self.shardImg.data = Lua_ToolVo.new(shard.shard_id);
	if self.selectedData.level ~= 0  then
		self.shardImg:showNumLimit(self.selectedData.shard_number, Lua_FashionUtil.getupgradeConfig(self.selectedData.itemId, self.selectedData.level), 2);
	elseif self.selectedData.level == 0 and self.selectedData.active_type ~= 1 then
		self.shardImg:showNumLimit(self.selectedData.shard_number, Lua_FashionUtil.getShard_numberConfig(self.selectedData.itemId), 2);
	elseif self.selectedData.level == 0 and self.selectedData.active_type == 1 then
		self.shardImg:showNumLimit(self.selectedData.shard_number, Lua_FashionUtil.getupgradeConfig(self.selectedData.itemId, self.selectedData.level + 1), 2);
	end

	-- 显示战力
	if self.selectedData.level ~= 0 and self.selectedData.level > 0 then
		self.fightNum.num = self.selectedData:fashionForce(self.selectedData.level);
	else
		self.fightNum.num = self.selectedData:fashionForce(self.selectedData.level + 1);
	end

	-- 红点显示
	if self.selectedData.level ~= 0 then
		if self.selectedData.shard_number >= tonumber(Lua_FashionUtil.getupgradeConfig(self.selectedData.itemId, self.selectedData.level)) and maxLv + 1 > self.selectedData.level then
			self.redDot:setEnable(true);
		else
			self.redDot:setEnable(false);
		end
	elseif self.selectedData.level == 0 and self.selectedData.active_type ~= 1 then
		if self.selectedData.shard_number >= tonumber(Lua_FashionUtil.getShard_numberConfig(self.selectedData.itemId)) then
			self.redDot:setEnable(true);
		else
			self.redDot:setEnable(false);
		end
	elseif self.selectedData.level == 0 and self.selectedData.active_type == 1 then
		if self.selectedData.shard_number >= tonumber(Lua_FashionUtil.getupgradeConfig(self.selectedData.itemId, self.selectedData.level + 1)) then
			self.redDot:setEnable(true);
		else
			self.redDot:setEnable(false);
		end
	end

	if self.selectedData.active_type == 0 or self.selectedData.active_type == 2 and self.selectedData.level == 0 then
		self:showFasionParam(1);
		local state = self.selectedData.active_type == 2 or self.selectedData.active_type == 1;
		self.jihuoBtn.label = LanUtil.getValue(110351);
		self:setBtnShow(self.jihuoBtn, state);

		state = self.selectedData.active_type == 1;
		self.chuanBtn.label = LanUtil.getValue(110353);
		self:setBtnShow(self.chuanBtn, state);
	end

	if self.selectedData.active_type == 1 or self.selectedData.is_wear == 1 then
		if self.selectedData.level == 0 then
			self:showFasionParam(1);
		elseif self.selectedData.level ~= 0 and self.selectedData.level < maxLv + 1 then
			self:showFasionParam(self.selectedData.level,self.selectedData.level + 1);
		elseif self.selectedData.level ~= 0 and self.selectedData.level >= maxLv + 1 then
			self:showFasionParam(self.selectedData.level,self.selectedData.level);
		end

		self.jihuoBtn.label = LanUtil.getValue(110350);
		self:setBtnShow(self.jihuoBtn, true);

		if self.selectedData.is_wear == 1 then
			self.chuanBtn.label = LanUtil.getValue(110352);
		elseif self.selectedData.is_wear == 0 then
			self.chuanBtn.label = LanUtil.getValue(110353);
		end
		self:setBtnShow(self.chuanBtn, true);
	end

	if self.selectedData.level ~= 0 and self.selectedData.level >= maxLv + 1 then
		self:setBtnShow(self.jihuoBtn, false);

		self.txtLabel:setEnable(true);
		self.txtLabel.text = LanUtil.getValue(120537);
		if self.shardImg ~= nil then
			self.shardImg:setEnable(false);
		end
	else
		self:setBtnShow(self.jihuoBtn, true);

		self.txtLabel:setEnable(false);
		if self.shardImg ~= nil then
			self.shardImg:setEnable(true);
		end
	end
	self:updateFashionModel();
end

function Lua_FasionInsidePanel:setBtnShow(btn, state)
	local normalStr = Lua_ColorDefine.transColor("FFFFFF");
	local grayStr = Lua_ColorDefine.transColor("B6B6B6");
	local state = self.selectedData.active_type == 2 or self.selectedData.active_type == 1;
	btn:setMouseEnable(state);
	btn:setStyle(state and 13 or 12);
	btn.txt.colorStr = state and normalStr or grayStr;
end

function Lua_FasionInsidePanel:showFasionParam(showLv, nextLv)
	local fid = self.selectedData.itemId;
	local index = 1;
	for i = 1, self.paramItems:getSize() do
		self.paramItems[i]:setEnable(false);
	end

	for i,v in ipairs(Lua_ThingDefine.params) do
		local paramObj = Lua_FashionUtil.getAttConfig(fid, v);
		if paramObj ~= nil and self.paramItems[index] ~= nil then
			self.paramItems[index]:setEnable(true);

			local showLvStr;
			local nextLvStr;
			if Lua_ThingDefine.isPercentParam(v) then
				showLvStr = paramObj[showLv].. "%";
				if nextLv ~= nil then
					nextLvStr = tostring(paramObj[nextLv] - paramObj[showLv]) .. "%";
				end
			else
				showLvStr = paramObj[showLv];
				if nextLv ~= nil then
					nextLvStr = paramObj[nextLv] - paramObj[showLv];
				end
			end

			if nextLv == nil then
				self.paramItems[index]:setData(v, showLvStr);
			else
				self.paramItems[index]:setData(v, showLvStr, nextLvStr);
			end
			index = index + 1;
		end
	end
end

function Lua_FasionInsidePanel:updateFashionModel()
end

function Lua_FasionInsidePanel:onShiZhuangSpClick(go)
	Lua_WindowUtil.openWin("Lua_FashionAttributeWindow");
end

function Lua_FasionInsidePanel:onJiHuoClick()
	if self.selectedData.active_type == 2 then
		local msg = ProtoPublic_pb.Proto11402602();
		msg.fashion_id = self.selectedData.itemId
		sendMsg(11402602, msg);
	elseif self.selectedData.active_type == 1 then
		local msg = ProtoPublic_pb.Proto11402603();
		msg.fashion_id = self.selectedData.itemId
		sendMsg(11402603, msg);
	end
end

function Lua_FasionInsidePanel:onChuanDaiClick()
	if self.selectedData.is_wear == 0 then
		local msg = ProtoPublic_pb.Proto11402605();
		msg.fashion_id = self.selectedData.itemId
		sendMsg(11402605, msg);
		self.chuanBtn.label = LanUtil.getValue(110352);
	elseif self.selectedData.is_wear == 1 then
		local msg = ProtoPublic_pb.Proto11402604();
		msg.fashion_info = self.selectedData.itemId
		sendMsg(11402604, msg);
		self.chuanBtn.label = LanUtil.getValue(110353);
	end
end

function Lua_FasionInsidePanel:dispose()
	self:superCall("dispose");
	if self.txtLabel ~= nil then
		self.txtLabel:dispose();
		self.txtLabel = nil;
	end
	DataCenter.FashionData._id = nil;
end