checkRequire("Lua_FasionItemPanel");
checkRequire("Lua_FasionChatPanel");
checkRequire("Lua_FasionBgPanel");
checkRequire("Lua_FasionSuitPanel");
checkRequire("Lua_FashionUtil");
Lua_FasionPanel = class("Lua_FasionPanel", Lua_DisplayObject);
function Lua_FasionPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FasionPanel:buildShowItem()
	self:superCall("buildShowItem");

    self.panels = {};
    self.panels[1] = Lua_FasionItemPanel; -- 衣服
    self.panels[2] = Lua_FasionItemPanel; -- 武器
    self.panels[3] = Lua_FasionItemPanel; -- 装饰
    self.panels[4] = Lua_FasionChatPanel; -- 相框
    self.panels[5] = Lua_FasionChatPanel; -- 相气泡
    self.panels[6] = Lua_FasionBgPanel; -- 背景
    self.panels[7] = Lua_FasionSuitPanel; -- 套装

    self.btnNames = Array();
	self.btnNames:add({name = LanUtil.getValue(110005), eventIds = {11503,11506}});
	self.btnNames:add({name = LanUtil.getValue(110006), eventIds = {11502,11505}});
	self.btnNames:add({name = LanUtil.getValue(110007), eventIds = {11501,11504}});

	if getShowTips() == true then
		self.btnNames:add({name = LanUtil.getValue(110359), eventIds = {11507, 11508}});
		self.btnNames:add({name = LanUtil.getValue(110360), eventIds = {11509, 11510}});
		self.btnNames:add({name = LanUtil.getValue(110366), eventIds = {11511, 11512}, openId = 10168});
		self.btnNames:add({name = LanUtil.getValue(110361), eventIds = {15006}});
	end

	self.fasionList = Lua_ButtonList.new(self.content, self.btnNames, 152, self, self.onButtonListClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 148, 66), Vector4(0, 0, 148, 66),
		Lua_ColorDefine.transColor("FFFFFF"), Lua_ColorDefine.WHITE, Vector4(28, 28, 148, 30), 2, "common_atlas_1");
	self.fasionList:setLocation(-541, 251.5, 0);
	self.fasionList:setDepth(5);
	self.fasionList:setRedDotPos(65, 24);

	local isShowIcon;
	for i = 1, self.btnNames:getSize() do
		isShowIcon = true;
		if self.btnNames[i].openId == nil or DataCenter.funcOpenData:isOpened(self.btnNames[i].openId) == true then
			self.fasionList:setBtnGray(false, i, isShowIcon);
		else
			local cfg = getConfig({"func_open", self.btnNames[i].openId});
			if cfg ~= nil and cfg.advance_function ~= nil then
				isShowIcon = cfg.advance_function == 1
			end
			self.fasionList:setBtnGray(true, i, isShowIcon);
		end
	end

	self:addLuaEvent("FASHION_JIHUODATE", self, self.onUpdateFashionInfo);
	self:addLuaEvent("FASHION_UPDATE", self, self.onUpdateFashionInfo);
	sendMsg(11402601);
	sendMsg(11402606);
end

function Lua_FasionPanel:onButtonListClick(val)
	if self.btnNames[val].openId ~= nil and DataCenter.funcOpenData:isOpened(self.btnNames[val].openId) == false then
		local cfg = getConfig( { "func_open", self.btnNames[val].openId });
		if cfg ~= nil and cfg.advance_message ~= nil then
			OperateAlert.show(cfg.advance_message);
			return
		end
	end

	self.selectIndex = val;
	local showPanel = self.panels[self.selectIndex];
	if self.curPanel == nil or showPanel.classname ~= self.curPanel.classname then
		if self.curPanel ~= nil then
			self.curPanel:dispose();
			self.curPanel = nil;
		end
		self.curPanel = showPanel.new(self.content);
	end
	self.curPanel:setData(self.selectIndex);
end

function Lua_FasionPanel:onUpdateFashionInfo()
	if DataCenter.FashionData._id ~= nil then
		local list = DataCenter.FashionData.getIndex;
		self.selectIndex = list.btn_index;
		self.fasionList:setSelected(self.selectIndex, false);
	end

	if self.selectIndex == nil then
		self.selectIndex = 1;
		self.fasionList:setSelected(1, false);
	end
	self:onButtonListClick(self.selectIndex);
end

function Lua_FasionPanel:dispose()
	if self.panels ~= nil then
		self.panels = nil;
	end
	if self.btnNames ~= nil then
		self.btnNames:dispose();
		self.btnNames:clear();
		self.btnNames = nil;
	end
	if self.fasionList ~= nil then
		self.fasionList:dispose();
		self.fasionList = nil;
	end
	DataCenter.FashionData:clearDefaultData();
	
	self:superCall("dispose");
end