checkRequire("Lua_FasionInsidePanel");
checkRequire("Lua_ModelPlayer");
Lua_FasionSuitPanel = class("Lua_FasionSuitPanel", Lua_FasionInsidePanel);
function Lua_FasionSuitPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FasionSuitPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.roleBg:setUrl("/images/role/ui_figure_bg_01.png");
	
	self.interfaceTxt:setEnable(false);
	self.chuanBtn:setEnable(false);
	self.jihuoBtn:setEnable(false);
	self.shardImg:setEnable(false);
	self.fasionDragList:setEnable(false);

	self.clickNum = 0;

	self.txtLabel.text = LanUtil.getValue(20);
	self.desTxt2.text = LanUtil.getValue(110363);

	self.headBg = UICreate.createUIAtlasImage(self.content, "", "", 158, 152, 100, 100);
	self.headBg.name = "headBg";
	self.headBg:setDepth(2);
	self.headBg:setEnable(false);

	self.headImg = UICreate.createImage(self.content, "", 158, 150, 0, 0);
	self.headImg.name = "headImg";
	self.headImg.pivot = UIWidget.Pivot.Center;
	self.headImg:setDepth(3);
	self.headImg:SetDimensions(70, 70);
	self.headImg:setEnable(false);
				
	self.headFrame = UICreate.createUIAtlasImage(self.content, "", "", 158, 158, 100, 110);
	self.headFrame.name = "headFrame";
	self.headFrame:setDepth(4);
	self.headFrame:setEnable(false);
		
	self.bubbleImg = UICreate.createUIAtlasImage(self.content, "", "", 156, 60, 90, 90);
	self.bubbleImg.name = "bubbleImg";
	self.bubbleImg:setDepth(2);
	self.bubbleImg:setEnable(false);

	self.suitDragListBg =  UICreate.createUIAtlasImage(self.content, "role_atlas", "ui_figure_d1", -36, -285, 497, 125);
	self.suitDragListBg.name = "suitDragListBg";
	self.suitDragListBg:setDepth(2);

	self.suitDragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 492, 110));
	self.suitDragList:setLocation(-36.5, -288, 0);
	self.suitDragList:setListCell(Lua_FasionSuitItem, 110, 82, 10);
	-- self.suitDragList:setScale(0.95, 0.95, 0.95);

	self.planLabel = UICreate.createLabel(self.content, "", -270, -205, 235, 30, 22);
	self.planLabel.name = "planLabel";
	self.planLabel.pivot = UIWidget.Pivot.Left;
	self.planLabel.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.planLabel:setDepth(5);

	self.dressBtn = UICreate.createButton(self.content, LanUtil.getValue(110364), 368, -296.5, 192, 66);
	self.dressBtn.name = "dressBtn";
	self.dressBtn.txt.fontSize = 26;
	self.dressBtn.txt:setLocation(0, 3, 0);
	self.dressBtn:setDepth(2);
	self.dressBtn:addClickFuntion(self, self.onDressBtnClick);

	self:addLuaEvent("FASHION_SUIT_UPDATE", self, self.updateSuitInfo);
	sendMsg(11402606);
end

function Lua_FasionSuitPanel:updateSuitInfo()
	if self.btnList == nil then
		local arr = DataCenter.FashionData.getFashionSuitClass;
		self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, 0, 268, 525),
			Vector3(268, 65, 0), Vector3(244, 46, 0), Vector2(0, 0), Vector3(0, 17));
		self.btnList:setLocation(-462, -62, 0);
		self.btnList:setDepth(5);
		self.btnList:setMainBtnStyle("common_atlas_1", "ui_common_btn_p2", "ui_common_btn_p1", "D5DADE", "FFFFFF", 28);
		self.btnList:setSubBtnStyle("common_atlas_1", "ui_common_btn_p4", "ui_common_btn_p3", "92A0DA", "FFFCB7", 26);
		self.btnList:setData(arr, self, self.onButtonListClick, 2, 226);

		local list = DataCenter.FashionData.acti_suit_list;
		local suitNum = DataCenter.FashionData.getFashionSuitInfo:getSize();
		if #list == suitNum then
			self.btnList:setMainSlected(1, 1);
		else
			self.btnList:setMainSlected(2, 1);
		end
		self:updateShowClassRed();
	end
end

function Lua_FasionSuitPanel:onButtonListClick(data)
	if data.data == nil then -- 已激活套装为空
		if self.playerModel ~= nil then
			self.playerModel:dispose();
			self.playerModel = nil;
		end

		if self.faqiEffect ~= nil then
			self.faqiEffect:dispose();
			self.faqiEffect = nil;
		end

		if self.servantModel ~= nil then
			self.servantModel:dispose();
			self.servantModel = nil;
		end
		self.headBg:setEnable(false);
		self.headImg:setEnable(false);
		self.headFrame:setEnable(false);
		self.bubbleImg:setEnable(false);
		self.suitDragList:clearList();
		self.planLabel:setEnable(false);
		self.dressBtn:setEnable(false);
		self.redDot:setEnable(false);

		for i = 1, self.paramItems:getSize() do
			self.paramItems[i]:setEnable(false);
		end
		self.fightNum.num = 0;
		return;
	end

	self.selectedData = data;

	self.dressBtn:setEnable(true);
	local num = 0;
	local totalNum;
	local curProgress = 0;
	if data.data.isActivateSuit == true then -- 已激活套装
		self.clickNum = 0;
		self.dressBtn.label = LanUtil.getValue(110364);

		local arr = data.data.itemArr;
		self.suitDragList:setLuaArrayData(arr, false);
		totalNum = arr:getSize();
		curProgress = arr:getSize();
	else -- 未激活套装
		self.dressBtn.label = LanUtil.getValue(110351);

		local arr = data.data.itemArr;
		self.suitDragList:setLuaArrayData(arr, false);
		totalNum = arr:getSize();
		for i = 1, totalNum do
			if arr[i].isActivate ~= true then
				num = num + 1;
			else
				curProgress = curProgress + 1;
			end
		end
	end
	self.redDot:setEnable(data.data.isActivateSuit == false and totalNum == (totalNum - num));

	local state = data.data.isActivateSuit == true or (data.data.isActivateSuit == false and totalNum == (totalNum - num));
	local normalStr = Lua_ColorDefine.transColor("FFFFFF");
	local grayStr = Lua_ColorDefine.transColor("B6B6B6");
	self.dressBtn:setMouseEnable(state);
	self.dressBtn:setStyle(state and 13 or 12);
	self.dressBtn.txt.colorStr = state and normalStr or grayStr;

	self.planLabel:setEnable(true);
	self.planLabel.text = LanUtil.formateStr(LanUtil.getValue(110362), tostring(totalNum - num), tostring(totalNum));
	self:showFasionParam(data.data.id);
	self.fightNum.num = Lua_FashionUtil.getFashionSuitForce(data.data.id);

	self:updateFashionSuitShow();
	self:updateShowClassRed();
end

function Lua_FasionSuitPanel:updateShowClassRed()
	local redList = DataCenter.FashionData.updateClassRedList;
	self.btnList:setRedDot(1, redList);
	self:updateShowSubRed();
end

function Lua_FasionSuitPanel:updateShowSubRed()
	if self.selectedData == nil then
		return;
	end
	local subRedList = DataCenter.FashionData.updateSubRedList;
	self.btnList:setRedDot(2, subRedList[self.selectedData.mainIndex]);
end

function Lua_FasionSuitPanel:updateFashionSuitShow() -- 套装显示效果
	self.headBg:setEnable(false);
	self.headImg:setEnable(false);
	self.headFrame:setEnable(false);
	self.bubbleImg:setEnable(false);

	self.fashionClothesId = nil;
	self.fashionWeaponId = nil;
	self.fashionHeadId = nil;
	self.faqiId = nil;
	self.spoorId = nil;
	self.fairyId = nil;
	self.mountId = nil;
	self.servantTrans_id = nil;
	self.servantWeapon_id = nil;
	self.servantMount_id = nil;
	self.servantWing_id = nil;
	self.servantPos_x = 110;

	if self.selectedData ~= nil then
		local tvo;
		local arr = self.selectedData.data.itemArr;
		for i = 1, arr:getSize() do
			tvo = Lua_ToolVo.createToolVo(arr[i].id, 1, 0);
			if tvo.subType == Lua_PackTypeDefine.HEADFRAME_OR_BUBBLE then -- 相框、气泡
				if tvo.part == 4 then
					self.headBg:setEnable(true);
					self.headImg:setEnable(true);
					self.headFrame:setEnable(true);

					local atlas = getConfig({"chat_attire", tvo.id, "left_atlas"});
					local sprite = getConfig({"chat_attire", tvo.id, "left_sprit"});
					local frame_bg = getConfig({"chat_attire", tvo.id, "frame_bg"});
					self.headFrame:setAltas(atlas, sprite);
					self.headBg:setAltas(atlas, frame_bg);

					local roleData = DataCenter.roleData;
					self.headImg:setUrl(Lua_ThingDefine.getFashionHeadIconUrlByCareer(roleData.career, roleData.profession));
				end
				if tvo.part == 5 then
					self.bubbleImg:setEnable(true);
					local tvo = Lua_ToolVo.createToolVo(tvo.id);
					self.bubbleImg:setAltas(tvo.atlas, tvo.id);
				end
			elseif tvo.subType == Lua_PackTypeDefine.FASION then -- 头饰、武器、时装
				if tvo.part == 1 then
					self.fashionHeadId = Lua_FashionUtil:getFashionItemId(tvo.id);
				end
				if tvo.part == 2 then
					self.fashionWeaponId = Lua_FashionUtil:getFashionItemId(tvo.id);
				end
				if tvo.part == 3 then
					self.fashionClothesId = Lua_FashionUtil:getFashionItemId(tvo.id);
				end
			elseif tvo.subType == Lua_PackTypeDefine.FOOT_PRINT then -- 足迹
				self.spoorId = Lua_FashionUtil:getTipShowModelId(tvo.id);
			elseif tvo.subType == Lua_PackTypeDefine.MAGIC_WEAPON then -- 法宝
				self.faqiId = Lua_FashionUtil:getTipShowModelId(tvo.id);
			elseif tvo.subType == Lua_PackTypeDefine.FAIRY_DEVICE then -- 仙器
				self.fairyId = Lua_FashionUtil:getTipShowModelId(tvo.id);
			elseif tvo.subType == Lua_PackTypeDefine.ROLE_MOUNT then -- 角色坐骑
				self.mountId = Lua_FashionUtil:getTipShowModelId(tvo.id);
			elseif tvo.subType == Lua_PackTypeDefine.SERVANT_TRANS then -- 侍宠
				self.servantTrans_id = Lua_FashionUtil:getTipShowModelId(tvo.id);
			elseif tvo.subType == Lua_PackTypeDefine.SERVANT_WEAPON_TRANS then -- 宠武
				self.servantWeapon_id = Lua_FashionUtil:getTipShowModelId(tvo.id);
			elseif tvo.subType == Lua_PackTypeDefine.SERVANT_MOUNT_TRANS then -- 宠骑
				self.servantMount_id = Lua_FashionUtil:getTipShowModelId(tvo.id);
			elseif tvo.subType == Lua_PackTypeDefine.SERVANT_WING_TRANS then -- 宠翼
				self.servantWing_id = Lua_FashionUtil:getTipShowModelId(tvo.id);
			end
		end
	end
	local payerrPos = self.selectedData.data.person_pos;
	local playerAngles = self.selectedData.data.person_rot;
	self.payerrPos = Vector3(payerrPos[1], payerrPos[2], payerrPos[3]);
	self.playerAngles = Vector3(playerAngles[1], playerAngles[2], playerAngles[3]);
	self.playerScale = self.selectedData.data.person_sca;

	local servantPos = self.selectedData.data.servant_pos;
	local servantAngles = self.selectedData.data.servant_rot;
	self.servantPos = Vector3(servantPos[1], servantPos[2], servantPos[3]);
	self.servantAngles = Vector3(servantAngles[1], servantAngles[2], servantAngles[3]);
	self.servantScale = self.selectedData.data.servant_sca;

	self.faqiPosX = self.selectedData.data.magicweapon_pos[1];
	self.faqiPosY = self.selectedData.data.magicweapon_pos[2];
	self.faqiPosZ = self.selectedData.data.magicweapon_pos[3];
	if self.servantTrans_id ~= nil or self.servantWeapon_id ~= nil
		or self.servantMount_id ~= nil or self.servantWing_id ~= nil then
		self:updateServantModel();
	else
		if self.servantModel ~= nil then
			self.servantModel:dispose();
			self.servantModel = nil;
		end
	end
	self:updatePlayerModel();
end

function Lua_FasionSuitPanel:onDressBtnClick()
	if self.selectedData.data.isActivateSuit == true then -- 已激活套装
		if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
			OperateAlert.show(LanUtil.getValue(121419));
			return;
		end
		self.clickTime = getTime();

		self.clickNum = self.clickNum + 1;
		if self.clickNum > 1 then
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110365), tostring(self.selectedData.data.suit_name)));
			return;
		end

		-- 已激活套装穿戴，要发送消息号，Lua_FashionSuitVo
		local tvo;
		local arr = self.selectedData.data.itemArr;
		for i = 1, arr:getSize() do
			tvo = Lua_ToolVo.createToolVo(arr[i].id, 1, 0);
			if tvo.subType == Lua_PackTypeDefine.HEADFRAME_OR_BUBBLE or tvo.subType == Lua_PackTypeDefine.FASION then -- 时装、武器、装饰、相框、气泡
				DataCenter.FashionData:sWearFashion(tvo.id); -- 穿戴新的时装
			elseif tvo.subType == Lua_PackTypeDefine.FOOT_PRINT then -- 足迹
				local tipShowModelId = Lua_FashionUtil:getTipShowModelId(tvo.id);
				DataCenter.footprintTransData:sTransmogrify(tonumber(tipShowModelId));
			elseif tvo.subType == Lua_PackTypeDefine.MAGIC_WEAPON then -- 法宝
				local tipShowModelId = Lua_FashionUtil:getTipShowModelId(tvo.id);
				DataCenter.magicWeaponTransData:sTransmogrify(tonumber(tipShowModelId));
			elseif tvo.subType == Lua_PackTypeDefine.FAIRY_DEVICE then -- 仙器
				local tipShowModelId = Lua_FashionUtil:getTipShowModelId(tvo.id);
				DataCenter.talismanTransData:sTransmogrify(tonumber(tipShowModelId));
			elseif tvo.subType == Lua_PackTypeDefine.ROLE_MOUNT then -- 角色坐骑
				local tipShowModelId = Lua_FashionUtil:getTipShowModelId(tvo.id);
				DataCenter.mountTransData:sTransmogrify(tonumber(tipShowModelId));
			elseif tvo.subType == Lua_PackTypeDefine.SERVANT_TRANS then -- 侍宠
				local tipShowModelId = Lua_FashionUtil:getTipShowModelId(tvo.id);
				DataCenter.servantTransData:sTransmogrify(tonumber(tipShowModelId));
			elseif tvo.subType == Lua_PackTypeDefine.SERVANT_WEAPON_TRANS then -- 宠武
				local tipShowModelId = Lua_FashionUtil:getTipShowModelId(tvo.id);
				DataCenter.servantWeaponTransData:sTransmogrify(tonumber(tipShowModelId));	
			elseif tvo.subType == Lua_PackTypeDefine.SERVANT_MOUNT_TRANS then -- 宠骑
				local tipShowModelId = Lua_FashionUtil:getTipShowModelId(tvo.id);
				DataCenter.servantMountTransData:sTransmogrify(tonumber(tipShowModelId));
			elseif tvo.subType == Lua_PackTypeDefine.SERVANT_WING_TRANS then -- 宠翼
				local tipShowModelId = Lua_FashionUtil:getTipShowModelId(tvo.id);
				DataCenter.servantWingTransData:sTransmogrify(tonumber(tipShowModelId));			
			end
		end
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110365), tostring(self.selectedData.data.suit_name)));
	else
		DataCenter.FashionData:sActivateSuit(self.selectedData.data.id);
		if self.btnList ~= nil then
			self.btnList:dispose();
			self.btnList = nil;
		end
	end
end

function Lua_FasionSuitPanel:showFasionParam(suitId)
	local index = 1;
	for i = 1, self.paramItems:getSize() do
		self.paramItems[i]:setEnable(false);
	end

	local attrValue;
	local changeValue;
	for i,v in ipairs(Lua_ThingDefine.params) do
		attrValue = Lua_FashionUtil.getFashionSuitProperty(suitId, v);
		if attrValue ~= nil then
			changeValue = Lua_ThingDefine.isPercentParam(v) and attrValue[1] .. "%" or attrValue[1];
			self.paramItems[index]:setData(v, changeValue);
			self.paramItems[index]:setEnable(true);
			
			index = index + 1;
		end
	end
end

function Lua_FasionSuitPanel:updatePlayerModel()
	self.modelData = UsData();
	self.modelData.career = DataCenter.roleData.career;
	self.modelData.gender = 1;
	self.modelData.weapon_id = DataCenter.roleData.weapon_id;
	self.modelData.clothes_id = DataCenter.roleData.clothes_id;
	if self.mountId ~= nil then
		self.modelData.mount_id = self.mountId;
	end
	if self.fairyId ~= nil then
		self.modelData.fairyId = self.fairyId;
	end
	if self.spoorId ~= nil then
		self.modelData.spoorId = self.spoorId;
	end
	if self.fashionWeaponId ~= nil then
		self.modelData.fashion_weapon_id = self.fashionWeaponId;
	end
	if self.fashionHeadId ~= nil then
		self.modelData.fashionHeadId = self.fashionHeadId;
	end
	if self.fashionClothesId ~= nil then
		self.modelData.fashion_clothes_id = self.fashionClothesId;
	end
	self.modelData.nickname = "";
	self.modelData.hp = 1;
	self.modelData.kind = 1;
	self.modelData.isShowName = true;
	self.modelData.IsUI = true;
	self.modelData.showShadow = false;
	self.modelData.curState:setState(4, true);

	-- 玩家
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	if self.playerModel == nil then
		self.playerModel = Lua_ModelPlayer.new(self.content);
		self.playerModel.mount_id = self.mountId;
		self.playerModel:init(self.payerrPos, self.playerAngles, self.modelData, self.playerScale);
		self.playerModel:setRenderQueue(self.roleBg, 5, 2, false);
		self.playerModel:setRotEnable(true, 0, 153, 300, 300, 10);
	end

	if self.faqiId ~= nil then
		if self.faqiEffect ~= nil then
			self.faqiEffect:dispose();
			self.faqiEffect = nil;
		end

		local modelInfo = DataCenter.servantData:getModelInfo(tonumber(self.faqiId));
		if self.faqiEffect == nil then
			self.faqiEffect = UICreate.createUIEffect(self.content, modelInfo.floder.."/"..modelInfo.fileName, tostring(modelInfo.modelName), 0, 0);
			self.faqiEffect:SetRenderQueue(self.desTxt2, 3, 2, false);
			self.faqiEffect:setRot(0 , 180, 0);
			self.faqiEffect:setSacle(160, 160, 160);
			self.faqiEffect:setLocation(self.faqiPosX, self.faqiPosY, self.faqiPosZ);
			self.faqiEffect:setAction(1);
			-- self.faqiEffect:setLoop(false);
		end
	else
		if self.faqiEffect ~= nil then
			self.faqiEffect:dispose();
			self.faqiEffect = nil;
		end
	end
end

function Lua_FasionSuitPanel:updateServantModel()
	initReflection();

	local tid = 700010001;
	if self.servantTrans_id ~= nil then
		tid = tonumber(self.servantTrans_id);
	end
	local weaponid = 0;
	if self.servantWeapon_id ~= nil then
		weaponid = tonumber(self.servantWeapon_id);
	end
	local wingid = 0;
	if self.servantWing_id ~= nil then
		wingid = tonumber(self.servantWing_id);
	end
	local mountid = 0;
	if self.servantMount_id ~= nil then
		mountid = tonumber(self.servantMount_id);
	end

	local t1 = typeof("PetData");
	local constructor = tolua.getconstructor(t1, typeof('System.Int32'), typeof('System.Int32'), typeof('System.Int32'), typeof('System.Int32'))
	self.ServantModelData = constructor:Call(1, 0, 0, 0);
	
	local field1 = tolua.getproperty(t1, 'beast_id');
	field1:Set(self.ServantModelData, tid, nil);
	field1:Destroy();

	field1 = tolua.getproperty(t1, 'mount_shape');
	field1:Set(self.ServantModelData, mountid, nil);
	field1:Destroy();

	field1 = tolua.getproperty(t1, 'weapon_shape');
	field1:Set(self.ServantModelData, weaponid, nil);
	field1:Destroy();

	field1 = tolua.getproperty(t1, 'wing_shape');
	field1:Set(self.ServantModelData, wingid, nil);
	field1:Destroy();

	field1 = tolua.getfield(t1, 'hp');
	field1:Set(self.ServantModelData, 1);
	field1:Destroy();

	field1 = tolua.getproperty(t1, 'showShadow');
	field1:Set(self.ServantModelData, false, nil);
	field1:Destroy();

	field1 = tolua.getfield(t1, 'IsUI');
	field1:Set(self.ServantModelData, true);
	field1:Destroy();

	-- 侍宠
	if self.servantModel ~= nil then
		self.servantModel:dispose();
		self.servantModel = nil;
	end
	if self.servantModel == nil then
		self.servantModel = Lua_ModelPlayer.new(self.content);
		self.servantModel.mount_id = mountid;
		self.servantModel:init(self.servantPos, self.servantAngles, self.ServantModelData, self.servantScale);
		self.servantModel:setRenderQueue(self.roleBg, 5, 2, false);
		self.servantModel:setRotEnable(true, 0, 153, 300, 300, 10);
	end
end

function Lua_FasionSuitPanel:dispose()
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	if self.faqiEffect ~= nil then
		self.faqiEffect:dispose();
		self.faqiEffect = nil;
	end
	if self.servantModel ~= nil then
		self.servantModel:dispose();
		self.servantModel = nil;
	end
	self.clickNum = nil;
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_FasionSuitItem = class("Lua_FasionSuitItem", Lua_ListCell);
function Lua_FasionSuitItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FasionSuitItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setCanClick(false);
	self.itemImg:setLocation(0, 15, 0);

	self.nameLabel = UICreate.createLabel(self.content, "", 0, -40, 235, 30, 18);
	self.nameLabel.name = "nameLabel";
	self.nameLabel.pivot = UIWidget.Pivot.Center;
	self.nameLabel.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.nameLabel:setDepth(1);

	self.itemActivate = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_bq_001", 0, 15, 0, 0);
	self.itemActivate.name = "itemActivate";
	self.itemActivate:setDepth(10);

	self.activateLabel = UICreate.createLabel(self.content, "", 0, 15, 235, 30, 18);
	self.activateLabel.name = "activateLabel";
	self.activateLabel.pivot = UIWidget.Pivot.Center;
	self.activateLabel.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.activateLabel:setDepth(11);
	self.activateLabel.text = LanUtil.getValue(127803);
end

function Lua_FasionSuitItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local tvo =  Lua_ToolVo.createToolVo(data.id, 1, 0)
	self.itemImg.data = tvo;

	if data.isActivate == true then -- 已激活道具
		self.itemImg:setGray(false);
		self.nameLabel.text = "[" .. tvo.colorStr .. "]" .. tvo.name .. "[-]";
		if self.itemActivate ~= nil and self.activateLabel ~= nil then
			self.itemActivate:setEnable(false);
			self.activateLabel:setEnable(false);
		end
	else -- 未激活道具
		self.itemImg:setGray(true);
		self.nameLabel.text = tvo.name;
		if self.itemActivate ~= nil and self.activateLabel ~= nil then
			self.itemActivate:setEnable(true);
			self.activateLabel:setEnable(true);
		end
	end
end

function Lua_FasionSuitItem:onPlayerSoundClick()
	Lua_PackUtil.showItemInfo(self.itemImg.data);
end

function Lua_FasionSuitItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.nameLabel ~= nil then
		self.nameLabel:dispose();
		self.nameLabel = nil;
	end
	if self.itemActivate ~= nil then
		self.itemActivate:dispose();
		self.itemActivate = nil;
	end
	if self.activateLabel ~= nil then
		self.activateLabel:dispose();
		self.activateLabel = nil;
	end
	self.data = ni;

	self:superCall("dispose");
end