Lua_FashionUtil = {};
function Lua_FashionUtil.getAttConfig(id, args)
	 return getConfig({ "fashion", id, "attributes", args})
end

function Lua_FashionUtil.getInterfaceConfig(id)
	return getConfig({"item", id, "interface_output"})
end

function Lua_FashionUtil.getInterfaceType(id)
	return getConfig({"item", id, "interface_type"})
end

function Lua_FashionUtil.getShard_numberConfig(id)
	local shard_numberConfig = getConfig({"fashion", id, "shard_number"})
	if shard_numberConfig ~= nil then
		return shard_numberConfig;
	end
end

function Lua_FashionUtil.getupgradeConfig(id, level)
	local upgradeConfig = getConfig({"fashion", id, "upgrade"})
	if upgradeConfig ~= nil then 
		if level > #upgradeConfig + 1 then
			return nil;
		elseif level == #upgradeConfig + 1 then
			return upgradeConfig[level - 1];
		elseif level < #upgradeConfig + 1 then
			return upgradeConfig[level];
		end
	end
end

function Lua_FashionUtil.getFasionMaxLevel(id)
	local upgradeConfig = getConfig({"fashion", id, "upgrade"})
	return #upgradeConfig;
end

function Lua_FashionUtil.getHealth(id, level)
	local healthConfig = Lua_FashionUtil.getAttConfig(id, "health")
	if healthConfig ~= nil then
		if level > #healthConfig then
			return nil;
		else
			return healthConfig[level];
		end
	end
end

function Lua_FashionUtil.geAttack(id, level)
	local attackConfig = Lua_FashionUtil.getAttConfig(id, "attack")
	if attackConfig ~= nil then 
		if level > #attackConfig then
			return nil;
		else
			return attackConfig[level];
		end
	end
end

function Lua_FashionUtil.getDefence(id, level)
	local defenceConfig = Lua_FashionUtil.getAttConfig(id, "defence")
	if defenceConfig ~= nil then 
		if level > #defenceConfig then
			return nil;
		else
			return defenceConfig[level];
		end
	end
end

function Lua_FashionUtil.getFashionSuitProperty(id, value)
	return getConfig({"suit", id, value});
end

function Lua_FashionUtil.getFashionSuitForce(id)
	local attributes = getConfig({"suit", id, "attributes"});
	local val;
	local list = {};
	for i = 1, #attributes do
		val = getConfig({"suit", id, attributes[i]});
		if val ~= nil then
			list[attributes[i]] = val[1];
		end
	end

	return Lua_FightUtil.caculateConfigForce(list);
end

function Lua_FashionUtil:getFashionItemId(id)
	return getConfig({"fashion", id, "itemId"});
end

function Lua_FashionUtil:getTipShowModelId(id)
	return getConfig({"item", id, "tipShowModel"});
end