checkRequire("Lua_JunXianUtil");
Lua_JunXianWindow = class("Lua_JunXianWindow", Lua_SecondSizeWindow)
function Lua_JunXianWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JunXianWindow";
	self.skinName = "JunXianWindow_skin";
	self.titleText = LanUtil.getValue(110163);
end

function Lua_JunXianWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11101));

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setScale(0.8, 0.8, 0.8);
	self.itemImg:setLocation(200, -180, 0);
	self.itemImg:setEnable(false);

	self.upBtn:addClickFuntion(self, self.onUpClick);

	self:addLuaEvent("SHOW_JUNXIANINFO", self, self.onShowInfo);
	self:addLuaEvent("ROLE_DATA_CHANGE", self, self.onUpdateForce);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.onRedDotUpdate);
	DataCenter.junXianData:sInitMsg();
end

function Lua_JunXianWindow:onShowInfo()
	if DataCenter.junXianData.is_grade_up == 1 then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110162), tostring(Lua_JunXianUtil.getJunxian(DataCenter.junXianData.mili_rank_lvl))));
	end

	local junXianData = DataCenter.junXianData;
	if junXianData.mili_rank_lvl == nil then
		return
	end
	self.curLbl.text = Lua_JunXianUtil.getJunxian(junXianData.mili_rank_lvl);

	local list1 = {};
	list1[Lua_FightUtil.BLOOD_MAX_STR] = Lua_JunXianUtil.getHealth(junXianData.mili_rank_lvl);
	list1[Lua_FightUtil.ATTACK_STR] = Lua_JunXianUtil.getAttack(junXianData.mili_rank_lvl);
	list1[Lua_FightUtil.DEFENCE_STR] = Lua_JunXianUtil.getDefence(junXianData.mili_rank_lvl);
	self.power.text = LanUtil.formateStr(LanUtil.getValue(110152), tostring(Lua_FightUtil.caculateConfigForce(list1)));
	self.hp.text = LanUtil.formateStr(LanUtil.getValue(110152), tostring(Lua_JunXianUtil.getHealth(junXianData.mili_rank_lvl)));
	self.attack.text = LanUtil.formateStr(LanUtil.getValue(110153), tostring(Lua_JunXianUtil.getAttack(junXianData.mili_rank_lvl)));
	self.defen.text = LanUtil.formateStr(LanUtil.getValue(110154), tostring(Lua_JunXianUtil.getDefence(junXianData.mili_rank_lvl)));

	local junXianConfig = getConfig({"military_rank", "junxian"});
    if junXianData.mili_rank_lvl == #junXianConfig then
		self.curLbl2.text = LanUtil.getValue(110160);

		self.attack2.colorStr = Lua_ColorDefine.transColor("FFFFFF");
		self.attack2.text = LanUtil.getValue(110161);
		self.attack2:setLocation(-83, -95, 0);

		self.need_force = Lua_JunXianUtil.getNedForce(junXianData.mili_rank_lvl - 1);
		self.itemID = Lua_JunXianUtil.getItemID(junXianData.mili_rank_lvl - 1);
		self.itemCount = Lua_JunXianUtil.getItemCount(junXianData.mili_rank_lvl - 1);
		self.had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.itemID);
		
		self.hpObj:SetActive(false);
		self.attackLbl:setEnable(false);
		self.defenObj:SetActive(false);
		self.needLbl:setEnable(false);
		self.valueLbl:setEnable(false);
		self.itemImg:setEnable(false);
		self.upBtn:setEnable(false);
		self.redDot:setEnable(false);
	else
		self.curLbl2.text = Lua_JunXianUtil.getJunxian(junXianData.mili_rank_lvl + 1);

		local list2 = {};
		list2[Lua_FightUtil.BLOOD_MAX_STR] = Lua_JunXianUtil.getHealth(junXianData.mili_rank_lvl + 1);
		list2[Lua_FightUtil.ATTACK_STR] = Lua_JunXianUtil.getAttack(junXianData.mili_rank_lvl + 1);
		list2[Lua_FightUtil.DEFENCE_STR] = Lua_JunXianUtil.getDefence(junXianData.mili_rank_lvl + 1);
		self.power2.text = LanUtil.formateStr(LanUtil.getValue(110155), tostring(Lua_FightUtil.caculateConfigForce(list2)));
		self.hp2.text = LanUtil.formateStr(LanUtil.getValue(110155), tostring(Lua_JunXianUtil.getHealth(junXianData.mili_rank_lvl + 1)));
		self.attack2.text = LanUtil.formateStr(LanUtil.getValue(110156), tostring(Lua_JunXianUtil.getAttack(junXianData.mili_rank_lvl + 1)));
		self.defen2.text = LanUtil.formateStr(LanUtil.getValue(110157), tostring(Lua_JunXianUtil.getDefence(junXianData.mili_rank_lvl + 1)));

		self.need_force = Lua_JunXianUtil.getNedForce(junXianData.mili_rank_lvl);

		self.itemID = Lua_JunXianUtil.getItemID(junXianData.mili_rank_lvl);
		self.itemCount = Lua_JunXianUtil.getItemCount(junXianData.mili_rank_lvl);
		self.had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.itemID);
		if self.itemCount ~= 0 then
			self.itemImg.data = Lua_ToolVo.new(self.itemID, self.itemCount);
			self.itemImg:showNumLimit(self.had_Count, self.itemCount, 2);
		end
		self.itemImg:setEnable(self.itemCount ~= 0);
	end
	self:onUpdateForce(DataCenter.roleData.force)
end

function Lua_JunXianWindow:onUpdateForce(value)
	if self.need_force < tonumber(value) then
		self.valueLbl.text = LanUtil.formateStr(LanUtil.getValue(110159), tostring(value), tostring(self.need_force));
	else
		self.valueLbl.text = LanUtil.formateStr(LanUtil.getValue(110150), tostring(value), tostring(self.need_force));
	end
	local posX = self.valueLbl.mainContent.transform.localPosition.x + self.valueLbl.width + 10 + self.itemImg.item_bg.width / 2;
	self.itemImg:setLocation(posX, -180, 0);
end

function Lua_JunXianWindow:onRedDotUpdate(obj)
	if obj == nil or obj.evenId == 11101 then
		self.redDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11101));
	end
end

function Lua_JunXianWindow:onUpClick(go)
	DataCenter.junXianData:sUpMsg();
end

function Lua_JunXianWindow:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end

	self:superCall("dispose");
end