checkRequire("Lua_TouchControler");
Lua_JieQuIconWindow = class("Lua_JieQuIconWindow", Lua_Window)
function Lua_JieQuIconWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JieQuIconWindow";
	self.skinName = "JieQuIconWindow_skin";
	self.showClose = false;
	self.isClickClose = false;
end

function Lua_JieQuIconWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.sureBtn:addClickFuntion(self, self.onSureClick);
	self.cancelBtn:addClickFuntion(self, self.hide);

	self._isClick = false;
	self.posX = 0;
	self.posY = 0;
	self.pos_cur = 195; -- 箭头默认位置值
	self.sizeW_cur = 400; -- 当前值
	self.sizeH_cur = 400;
	self.sizeW_min = 120; -- 最小值
	self.sizeH_min = 120;
	self.sizeW_max = 500; -- 最大值
	self.sizeH_max = 500;
	self:onCalcVal();
	self:setPos(0, 0);

	self.uploadImg = UICreate.createImage(self.content, "", 0, 0, 500, 500);
	self.uploadImg.pivot = UIWidget.Pivot.Center;
	self.uploadImg:setDepth(0);

	self.jieQuKuang.clickScale = false;
	self.jieQuKuang:addClickFuntion(self, self.onMoveDownClick);
	self.jieQuKuang:addMouseUpFuntion(self, self.onMoveUpClick);

	self:addLuaEvent("TOUCH_CHANGE", self, self.onTouchChange);
end

function Lua_JieQuIconWindow:showWin(param)
	self:superCall("showWin", param);

	self.uploadImg:setUrl(self.showData, 99, true);
end

function Lua_JieQuIconWindow:onTouchChange(val)
	if val == true then
		Lua_CommonUtil.addTimer("onEnlarge", 0.2, self, self.onEnlarge);
		self:onEnlarge();
	else
		Lua_CommonUtil.addTimer("onNarrow", 0.2, self, self.onNarrow);
		self:onNarrow();
	end
end

function Lua_JieQuIconWindow:onMoveDownClick(go)
	self:onPress(go, true);

	Lua_TouchControler.getInstance():startTouchCheck();
end

function Lua_JieQuIconWindow:onMoveUpClick(go)
	self:onPress(go, false);

	Lua_CommonUtil.removeTimer(self, self.onEnlarge);
	Lua_CommonUtil.removeTimer(self, self.onNarrow);
	Lua_TouchControler.getInstance():stopTouchCheck();
end

function Lua_JieQuIconWindow:onPress(go, state)
	if state == true then
		self.startMouseX = UnityEngine.Input.mousePosition.x;
		self.startMouseY = UnityEngine.Input.mousePosition.y;
		self.startPosX = self.posX;
		self.startPosY = self.posY;
		if self._isClick == false then
			self._isClick = true;
			Lua_CommonUtil.addTimer( "Lua_JieQuIconWindow", 0.01, self, self.onMoving);
		end
	else
		if self._isClick == true then
			self._isClick = false;
			Lua_CommonUtil.removeTimer(self, self.onMoving);
		end
	end
end

function Lua_JieQuIconWindow:onMoving()
	local dx = UnityEngine.Input.mousePosition.x - self.startMouseX;
	local dy = UnityEngine.Input.mousePosition.y - self.startMouseY;
	self:setPos(dx + self.startPosX, dy + self.startPosY)
end

function Lua_JieQuIconWindow:setPos(x, y)
	if x < self.X_min then
		self.posX = self.X_min;
	elseif x > self.X_max then
		self.posX = self.X_max;
	else
		self.posX = x;
	end

	if y < self.Y_min then
		self.posY = self.Y_min;
	elseif y > self.Y_max then
		self.posY = self.Y_max;
	else
		self.posY = y;
	end

	-- self.goContainer.transform.localPosition = Vector3(self.posX, self.posY, 0);
	LuaUtil.setObjPos(self.goContainer, self.posX, self.posY, 0);
end

function Lua_JieQuIconWindow:onEnlarge()
	self.sizeW_cur = self.sizeW_cur + 4;
	if self.sizeW_cur >= self.sizeW_max then
		self.sizeW_cur = self.sizeW_max;
	end

	self.sizeH_cur = self.sizeH_cur + 4;
	if self.sizeH_cur >= self.sizeH_max then
		self.sizeH_cur = self.sizeH_max;
	end
	self.jieQuKuang:SetDimensions(self.sizeW_cur, self.sizeH_cur);
	self.pos_cur = self.sizeW_cur / 2 - 5;

	self:onCalcVal();
	self:updateArrow();
end

function Lua_JieQuIconWindow:onNarrow()
	self.sizeW_cur = self.sizeW_cur - 4;
	if self.sizeW_cur <= self.sizeW_min then
		self.sizeW_cur = self.sizeW_min;
	end

	self.sizeH_cur = self.sizeH_cur - 4;
	if self.sizeH_cur <= self.sizeH_min then
		self.sizeH_cur = self.sizeH_min;
	end
	self.jieQuKuang:SetDimensions(self.sizeW_cur, self.sizeH_cur);
	self.pos_cur = self.sizeW_cur / 2 - 5;

	self:onCalcVal();
	self:updateArrow();
end

function Lua_JieQuIconWindow:onCalcVal()
	self.X_max = (self.sizeW_max - self.sizeW_cur) / 2;
	self.X_min = - self.X_max;
	self.Y_max = (self.sizeH_max - self.sizeH_cur) / 2;
	self.Y_min = - self.Y_max;
end

function Lua_JieQuIconWindow:updateArrow()
	self.up:setLocation(0, self.pos_cur);
	self.down:setLocation(0, -self.pos_cur);
	self.right:setLocation(self.pos_cur, 0);
	self.left:setLocation(-self.pos_cur, 0);

	self.up:SetDimensions(40, 40);
	self.down:SetDimensions(40, 40);
	self.right:SetDimensions(40, 40);
	self.left:SetDimensions(40, 40);
end

function Lua_JieQuIconWindow:onSureClick()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	local uploadUrl = "";
	if CommonUtil.isApplePlatform then
		uploadUrl = Lua_CommonUtil.getCommonConfig("head_upload_url_ios", 2);
	else
		if tostring(UnityEngine.Application.platform) == "WindowsEditor" or tostring(UnityEngine.Application.platform) == "WindowsPlayer" then
			uploadUrl = Lua_CommonUtil.getCommonConfig("head_upload_url_pc", 2);
		else
			uploadUrl = Lua_CommonUtil.getCommonConfig("head_upload_url_andriod", 2);
		end
	end

	if DataCenter.roleData.cutImage ~= nil then
		local str = DataCenter.roleData.cutImage;
		local x = 250 - (self.sizeW_cur / 2);
		local y = 250 - (self.sizeH_cur / 2);
		local val_left = x + math.floor(self.posX);
		local val_bottom = y + math.floor(self.posY);
		-- 路径，显示宽，显示高，裁剪左边偏移，裁剪与底边偏移，裁剪宽，裁剪高
		local bytes = ImageManager.getInstance():cutImage(str, self.sizeW_max, self.sizeW_max, val_left, val_bottom, self.sizeW_cur, self.sizeH_cur);
		UploadManager.getInstance():uploadFile(uploadUrl, bytes, tostring(DataCenter.roleData.roleId)..".png",self, self.onUploadEnd, self.onUploadError);
	end
end

function Lua_JieQuIconWindow:onUploadEnd(str)
	local obj = decodeJson(str);
	if obj.code == 1 then -- 上传成功
		-- print("file_name:", obj.file_name);
		DataCenter.roleData.uploadHead = obj.file_name;
		Lua_MsgUtil.callFunc("ROLE_HEAD_CHANGE");
		OperateAlert.show(LanUtil.getValue(129224));
	elseif obj.code == -1 then -- 上传签名错误
		OperateAlert.show(LanUtil.getValue(129216));
	elseif obj.code == -2 then -- 上传参数不完整
		OperateAlert.show(LanUtil.getValue(129217));
	elseif obj.code == -3 then -- 上传文件流为空
		OperateAlert.show(LanUtil.getValue(129218));
	elseif obj.code == -4 then -- 上传文件太大
		OperateAlert.show(LanUtil.getValue(129219));
	elseif obj.code == -5 then -- 文件保存失败
		OperateAlert.show(LanUtil.getValue(129220));
	elseif obj.code == -6 then -- 超过一天上传次数
		OperateAlert.show(LanUtil.getValue(129221));
	elseif obj.code == -7 then -- 限制上传
		OperateAlert.show(LanUtil.getValue(129222));
	elseif obj.code == 0 then -- 文件不存在
		OperateAlert.show(LanUtil.getValue(129223));
	end

	self:hide();
end

function Lua_JieQuIconWindow:onUploadError(str)
	print("onUploadError:", str);
end

function Lua_JieQuIconWindow:dispose()
	self._isClick = false;
	Lua_CommonUtil.removeTimer(self, self.onMoving);
	Lua_CommonUtil.removeTimer(self, self.onEnlarge);
	Lua_CommonUtil.removeTimer(self, self.onNarrow);
	Lua_TouchControler.getInstance():stopTouchCheck();
	if CommonUtil.isApplePlatform then
		self.uploadImg:clearResNow(true);
	end
	
	self:superCall("dispose");
end