Lua_ModifyHeadIconWindow = class("Lua_ModifyHeadIconWindow", Lua_Window)
function Lua_ModifyHeadIconWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ModifyHeadIconWindow";
	self.skinName = "ModifyHeadIconWindow_skin";
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_ModifyHeadIconWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.headIconItem = Lua_HeadIconItem.new(self.content);
	self.headIconItem:setLocation(4, 41, 0);

	local img_size = Lua_CommonUtil.getCommonConfig("img_size", 1) / 1024;
	self.tipsLabel.text = LanUtil.formateStr(LanUtil.getValue(129215), tostring(img_size));

	self.choiceBtn:addClickFuntion(self, self.onChoiceClick);
	self.saveBtn:addClickFuntion(self, self.onSaveClick);

	self:updateInfo();

	self:addLuaEvent("ROLE_HEAD_CHANGE", self, self.updateInfo);
	self:addCSharpEvent("SELECT_FILE", self, self.onSelectedFile);
end

function Lua_ModifyHeadIconWindow:updateInfo()
	local role_head = "";
	if DataCenter.roleData.uploadHead == nil then
		role_head = DataCenter.roleData.getDressHead;
	else
		role_head = DataCenter.roleData.uploadHead;
	end

	if role_head ~= nil then
		local frameData = DataCenter.FashionData:getIsWearDataByType(4);
		if frameData ~= nil then
			self.headIconItem:setData(DataCenter.roleData.career, role_head, DataCenter.roleData:getHeadFrame(frameData.id));
		else
			self.headIconItem:setData(DataCenter.roleData.career, role_head, nil);
		end
	end
end

function Lua_ModifyHeadIconWindow:onChoiceClick()
	SDKInterface.OpenAlbum();
end

function Lua_ModifyHeadIconWindow:onSelectedFile(str)
	if str == nil or type(str) ~= "string" then
		OperateAlert.show(LanUtil.getValue(129209));
	else
		local rs = ImageManager.getInstance():checkImg(str);
		--0 正常，1 超尺寸，2 超大小，3 不是图片文件，4 文件不存在
		if rs == 0 then
			local path = "";
			if CommonUtil.isApplePlatform then
				path = "file://"..str;
			else
				if tostring(UnityEngine.Application.platform) == "WindowsEditor" or tostring(UnityEngine.Application.platform) == "WindowsPlayer" then
					path = "file://"..str;
				else
					path = "file://"..str;
				end
			end
			DataCenter.roleData.cutImage = str;
			Lua_WindowUtil.openWin("Lua_JieQuIconWindow", WinParam.ACTION_OPEN, path);
		elseif rs == 1 then
			OperateAlert.show(LanUtil.getValue(129205));
		elseif rs == 2 then
			OperateAlert.show(LanUtil.getValue(129206));
		elseif rs == 3 then
			OperateAlert.show(LanUtil.getValue(129207));
		elseif rs == 4 then
			OperateAlert.show(LanUtil.getValue(129208));
		-- else
		-- 	OperateAlert.show("checkImg:"..rs);
		end	
	end
end

function Lua_ModifyHeadIconWindow:onSaveClick()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if DataCenter.roleData.uploadHead ~= nil then
		local role_head = DataCenter.roleData.uploadHead;
		Lua_ProxyManager.getProxy("Lua_PlayerProxy"):sSaveHeadIcon(role_head);
		OperateAlert.show(LanUtil.getValue(129213));

		DataCenter.roleData.cutImage = nil;
		DataCenter.roleData.uploadHead = nil;
		self:hide();
	else
		OperateAlert.show(LanUtil.getValue(129214));
	end
end

function Lua_ModifyHeadIconWindow:dispose()
	if self.headIconItem ~= nil then
		self.headIconItem:dispose();
		self.headIconItem = nil;
	end
	DataCenter.roleData.cutImage = nil;
	DataCenter.roleData.uploadHead = nil;
	
	self:superCall("dispose");
end