checkRequire("Lua_FashionUtil");
Lua_ModifyHeadWindow = class("Lua_ModifyHeadWindow", Lua_SecondSizeWindow)
function Lua_ModifyHeadWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ModifyHeadWindow";
	self.skinName = "ModifyHeadWindow_skin";
	self.titleText = LanUtil.getValue(129202);
end

function Lua_ModifyHeadWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.headIconItem = Lua_HeadIconItem.new(self.content);
	self.headIconItem:setLocation(-315, 50, 0);

	self.btnNames = Array();
	self.btnNames:add({name = LanUtil.getValue(129202), eventIds = {}});
	self.btnNames:add({name = LanUtil.getValue(110359), eventIds = {}});
	self.btnNames:add({name = LanUtil.getValue(110360), eventIds = {}});
	
	self.btnList = Lua_ButtonList.new(self.content, self.btnNames, 153, self, self.onBtnListClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 148, 66), Vector4(0, 0, 148, 66),
		Lua_ColorDefine.WHITE, Lua_ColorDefine.transColor("D2D8DC"), Vector4(28, 28, 148, 30), 2, "common_atlas_1");
	self.btnList:setLocation(25, 195, 0);
	self.btnList:setDepth(5);
	self.btnList:setRedDotPos(50, 13);

	self.itemDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 558, 390));
	self.itemDragList:setLocation(225, -40, 0);
	self.itemDragList:setListCell(Lua_ModifyHeadIconItem, 176, 186, 3);

	self.modifyBtn:addClickFuntion(self, self.onModifyClick);
	self.saveBtn:addClickFuntion(self, self.onSaveClick);

	self:addLuaEvent("FASHION_UPDATE", self, self.updateInfo);
	self:addLuaEvent("ROLE_HEAD_UPDATE", self, self.updateInfo);
	self:addLuaEvent("UPDATE_ITEM", self, self.onUpSelectItemClick);
	sendMsg(11402601); -- 相框、气泡
end

function Lua_ModifyHeadWindow:updateInfo()
	self.num1 = DataCenter.roleData.getDressHeadIndex;
	self.num2 = DataCenter.FashionData:getDressIndex(4);
	self.num3 = DataCenter.FashionData:getDressIndex(5);

	self.selectIndex = 1;
	self.btnList:setSelected(self.selectIndex, false);
	self:onBtnListClick(self.selectIndex);

	self.bubbleLabel.text = LanUtil.getValue(129200);
	self.frameName.text = LanUtil.getValue(129201);

	local bubbleData = DataCenter.FashionData:getIsWearDataByType(5);
	if bubbleData ~= nil and bubbleData.type == 5 then
		local list = DataCenter.roleData:getChatBubble(bubbleData.id);
		self.bubble:setAltas(list.atlas, list.sprite);
	else
		self.bubble:setAltas("role_atlas", "ui_figure_icon_txd1");
	end
end

function Lua_ModifyHeadWindow:onUpSelectItemClick(data)
	if self.selectId == 1 then
		self.num1 = data.index;
	elseif self.selectId == 2 then
		self.num2 = data.index;
	elseif self.selectId == 3 then
		self.num3 = data.index;
	end

	if data.data.type == 4 then
		self.frameData = data.data;
		local list = DataCenter.roleData:getHeadFrame(data.data.id);
		self.frameName.text = data.data.name;

		-- 对选择的头像根据是否穿戴头像框，对应显示圆形or菱形
		if self.headData == nil then
			self.headIconItem:setData(DataCenter.roleData.career, DataCenter.roleData.getDressHead, list);
		else
			self.headIconItem:setData(DataCenter.roleData.career, self.headData.role_head, list);
		end
	elseif data.data.type == 5 then
		self.bubbleData = data.data;
		local list = DataCenter.roleData:getChatBubble(data.data.id);
		self.bubble:setAltas(list.atlas, list.sprite);
	else
		self.headData = data.data;
		if self.frameData == nil then
			local frameData = DataCenter.FashionData:getIsWearDataByType(4);
			if frameData ~= nil and frameData.type == 4 then
				local list = DataCenter.roleData:getHeadFrame(frameData.id);
				self.headIconItem:setData(DataCenter.roleData.career, data.data.role_head, list);
			else
				self.headIconItem:setData(DataCenter.roleData.career, data.data.role_head, nil);
			end
		else
			local list = DataCenter.roleData:getHeadFrame(self.frameData.id);
			self.headIconItem:setData(DataCenter.roleData.career, data.data.role_head, list);
		end
	end
end

function Lua_ModifyHeadWindow:onBtnListClick(val)
	self.dataType = val + 2;
	self.itemDragList:clearList();

	self.selectId=val;
	local num = 0;
	if val == 1 then
		num = self.num1;
	elseif val == 2 then
		num = self.num2;
	elseif val == 3 then
		num = self.num3;
	end

	if self.num2 == nil or self.num3 == nil then
		self.itemDragList.curSelectedIdx = 0;
	end

	local arr = Array();
	if self.dataType > 3 then -- 相框、气泡
		local info = DataCenter.FashionData:getItemByType(self.dataType); 
		for i = 1, info:getSize() do
			arr:add({data = info[i], index = i})
		end
	else
		local headIconData = DataCenter.roleData.getHeadIconData;
		for i = 1, headIconData:getSize() do
			arr:add({data = headIconData[i], index = i})
		end
	end
	self.itemDragList:setLuaArrayData(arr, true);

	if num ~= nil then
		self.itemDragList:moveToIndex(math.floor(num / 3), true);
		self.itemDragList:setSelected(num);
	else
		self.itemDragList:moveToIndex(1, true);
	end
end

function Lua_ModifyHeadWindow:onModifyClick()
	Lua_WindowUtil.openWin("Lua_ModifyHeadIconWindow", WinParam.ACTION_OPEN);
end

function Lua_ModifyHeadWindow:onSaveClick()
	if self.frameData == nil and self.bubbleData == nil and self.headData == nil then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	local isSure = true;
	if self.headData ~= nil then
		if self.headData.isGray == true then
			OperateAlert.show(LanUtil.getValue(129212));
			isSure = false;
		end
	end

	if self.frameData ~= nil then
		if DataCenter.FashionData:isActivate(4, self.frameData.id) == false then
			OperateAlert.show(LanUtil.getValue(129210));
			isSure = false;
		end
	end

	if self.bubbleData ~= nil then
		if DataCenter.FashionData:isActivate(5, self.bubbleData.id) == false then
			OperateAlert.show(LanUtil.getValue(129211));
			isSure = false;
		end
	end

	if isSure == false then
		self.frameData = nil;
		self.bubbleData = nil;
		self.headData = nil;

		Lua_MsgUtil.callFunc("ROLE_HEAD_UPDATE");
		return;
	end

	if isSure == true then --所选头像、相框、气泡都处于激活状态才可穿戴
		if self.headData ~= nil then
			Lua_ProxyManager.getProxy("Lua_PlayerProxy"):sSaveHeadIcon(self.headData.role_head);
		end

		if self.frameData ~= nil then
			DataCenter.FashionData:sWearFashion(self.frameData.itemId);
		end
		
		if self.bubbleData ~= nil then
			DataCenter.FashionData:sWearFashion(self.bubbleData.itemId);
		end

		OperateAlert.show(LanUtil.getValue(129213));
	end
end

function Lua_ModifyHeadWindow:dispose()
	if self.headIconItem ~= nil then
		self.headIconItem:dispose();
		self.headIconItem = nil;
	end
	if self.btnNames ~= nil then
		self.btnNames:dispose();
		self.btnNames:clear();
		self.btnNames = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.itemDragList ~= nil then
		self.itemDragList:dispose();
		self.itemDragList = nil;
	end
	self.frameData = nil;
	self.bubbleData = nil;
	self.headData = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ModifyHeadIconItem = class("Lua_ModifyHeadIconItem", Lua_ListCell);
function Lua_ModifyHeadIconItem:ctor(p)
	self:superCall("ctor", p, "ModifyHeadItem_skin");
end

function Lua_ModifyHeadIconItem:buildShowItem()
	self:superCall("buildShowItem");

	self.headImg = UICreate.createImage(self.content, "", 0, 12, 82, 82);
	self.headImg.pivot = UIWidget.Pivot.Center;
	self.headImg:setDepth(2);
	self.headImg:setEnable(false);

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(0,15,0);
	self.itemImg:setCanClick(false);
end

function Lua_ModifyHeadIconItem:setData(data)
	self.data = data.data;
	self._data = data;

	local curType = self.data.type == 4 or self.data.type == 5;
	if curType then -- 相框、气泡
		local tvo = Lua_ToolVo.new(self.data.itemId);
		self.itemImg.data = tvo;

		if self.data.active_type == 1 then
			self.name.text = LanUtil.getValue(129203);
		else
			self.name.text = Lua_FashionUtil.getInterfaceConfig(self.data.itemId);
		end
	else
		if self.data.isDefault == true then -- 默认头像
			self.headImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(self.data.role_head, 0));
		else
			self.headImg:setUrl(self.data.role_head, 99, true);
			-- self.headImg:setRoundSize(1, 0.5, 0.5, 0.5); -- 菱形
			self.headImg:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
		end
		self.headImg:setGray(self.data.isGray);
		self.name.text = self.data.get_head;
	end
	self.headImg:setEnable(not curType);
	self.itemImg:setEnable(curType);
	self.itemImg:setGray((self.data.type == 4 or self.data.type == 5) and self.data.active_type ~= 1);
	self.tipsObj:SetActive(self.data.is_wear == 1 or self.data.is_dress == 1);
	self.selectIcon:setEnable(false);
end

function Lua_ModifyHeadIconItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.bg:setAltas("common_atlas_1", "ui_common_widget_d2");
		Lua_MsgUtil.callFunc("UPDATE_ITEM", self._data);
	else
		self.bg:setAltas("common_atlas_1", "ui_common_widget_d1");
	end
	self.selectIcon:setEnable(val);
end

function Lua_ModifyHeadIconItem:dispose()
	if self.headImg ~= nil then
		self.headImg:dispose();
		self.headImg = nil;
	end
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end

	self:superCall("dispose");
end